package gol;

// i wanted to add things like shoot(), console(), getPlayerXY(), etc. Not sure if im allowed to let model.Player use these functions.
// dont want to risk. Email me if that'd be okay, or if i should move this commanding class to somewhere else,
// maybe model, as if control over data (because this thing wont do anything else actually...)

public class Controller {
	
}
package gol;

import java.awt.event.KeyEvent;
import java.util.List;

import view.*;
import view.gui.*;
import model.*;

public class GoL implements View.MouseL, View.MouseMotionL, View.KeyL, View.FrameUpdateL {
	View view;
	Model model;
	
	MainMenu mainmenu;
	FixPaint paint;
	StatsWindow  stats;
	
	public GoL() {
		model = new Model();
		view = new View(model);
		view.addMouseMotionL(this);
		view.addFrameUpdateL(this);
		view.addKeyL(this);
		view.addMouseL(this);
		
		mainmenu = new MainMenu();
		model.getWM().add(mainmenu);
		mainmenu.initWM(model.getWM());
		mainmenu.move(20, 20);
		mainmenu.initsModel(model);
		
		stats = new StatsWindow();
		model.getWM().add(stats);
		stats.initWM(model.getWM());
		stats.move(300, 50);
		
		/*
		mainform = new MainForm(view);
		model.formPush(mainform);
		*/
		view.start();
	}
	
	public static void main(String[] args) {
		
		//System.out.println("[main] " + new Bullet(Bullet.Type.Creeper).getLongName());
		//System.out.println("[main[ " + new Bullet(Bullet.Type.Creeper).getLongType());
		
		GoL gol = new GoL();
	}

	@Override
	public void updateFrame(float delta) {
		/* 110629: commented out: minecraftification
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				Pixie pix = model.get(x,y);
				if (pix == null) { continue; }
				
				pix.update(model, delta);
				
				/*
				Player p = model.getPlayer();
				if (p == null) model.termPost("CORE[GoL.updateFrame]: mode.getPlayer() returned NULL!");
				** /
			}
		}
		List<Pixie> enten = model.entenGet();
		for (int i = 0; i < enten.size(); i++) {
			Pixie pix = enten.get(i);
			if (pix == null) continue;
			pix.update(model, delta);
		}
		
		model.getPlayer().update(model, delta);
		*/
	}

	 
	@Override
	public boolean mouseClicked(int x, int y) {
		if (model.useForms() && model.getWM().mouseClicked(x, y)) return true;
		
		// ===
		
		for (int i=0; i<4; i++) {
			/* 110629: commented out: minecraftification &&& simply no shooting
			Thing projectile = new Bullet(Bullet.Type.STD);
			// use 300f as speed
			model.getPlayer().shoot(x, y, 200f, (float)(Math.atan2(y-model.getPlayer().y, x-model.getPlayer().x)), projectile);
			model.entenAdd(projectile);
			*/
		}
		return true;
	}
	public boolean mouseMoved(int x, int y) {
		if (model.useForms() && model.getWM().mouseMoved(x, y)) return true;
		
		// ===
		
		return false;
	}
 	public boolean mouseDragged(int x, int y) {
		if (model.useForms() && model.getWM().mouseDragged(x, y)) return true;
		
		// ===
		
		return false;
		
		/*
		model.set((float)x  , (float)y  , new Dirt());
		model.set((float)x+1, (float)y  , new Dirt());
		model.set((float)x-1, (float)y  , new Dirt());
		model.set((float)x  , (float)y+1, new Dirt());
		model.set((float)x  , (float)y-1, new Dirt());
		*/
		//model.set(x-1, y-1, new Pixie(-1));
		//model.set(x-1, y+1, new Pixie(-1));
		//model.set(x+1, y-1, new Pixie(-1));
		//model.set(x+1, y+1, new Pixie(-1));
		//model.termPost("You set a pixel at x:"+x+"|y:"+y);
		//return true; // we consumed it.!
		//return false;
	}
	public boolean keyTyped(char letter) {
		if (model.useForms() && model.getWM().keyTyped(letter)) return true;
		
		// ===
		
		return false;
	}
	public boolean keyPressed(int code) {
		if (code == KeyEvent.VK_ESCAPE) { model.useForms(!model.useForms()); return true; }
		
		if (model.useForms() && model.getWM().keyPressed(code)) return true;
		
		
		switch (code) {
		/*case KeyEvent.VK_ESCAPE:
			model.useForms(!model.useForms()); // always toggle
			return true;*/
			
		case KeyEvent.VK_UP:
			model.getPlayer().move(model.getPlayer().getX(), model.getPlayer().getY()-1);
			break;
		
		case KeyEvent.VK_DOWN:
			model.getPlayer().move(model.getPlayer().getX(), model.getPlayer().getY()+1);
			break;
			
		case KeyEvent.VK_LEFT:
			model.getPlayer().move(model.getPlayer().getX()-1, model.getPlayer().getY());
			break;
			
		case KeyEvent.VK_RIGHT:
			model.getPlayer().move(model.getPlayer().getX()+1, model.getPlayer().getY());
			break;
			
//		case KeyEvent.VK_Q:
//			model.createMaze();
//			break;
		}
		return false;
	}

	public boolean mouseDown(int x, int y) {
		if (model.useForms() && model.getWM().mouseDown(x,y)) return true;
		return false;
	}
	public boolean mouseUp(int x, int y) {
		if (model.useForms() && model.getWM().mouseUp(x,y)) return true;
		return false;
	}
}


















package model;

import java.awt.Color;

import view.GSnip;

public enum Block {
	air,
	stone,
	player(0, true, null, 0.16D,0.16D,0.16D,0.16D, 0.15D),
	dirt,
	torch(0, false, null, 0.45d,0.45d,0.45d,0.45d, 0.30D); // TODO wire up torch

	private int data;								// at least 32bits of your own memory!
	private final boolean solid;					// can player walk through?
	private final GSnip icon;						// icon to appear in inventory
	private final double insl, insr, inst, insb;	// insets of the box (ie. set all to about 0.45d to get a centred stick(gonna use for torch) ) TODO make these affect anything actually...
	private final double light;						// how much light is being emmited. (0: none. 1:double sunlight?)

	Block(int data, boolean solid, GSnip icon, double insl, double insr, double inst, double insb, double light) {
		this.solid = solid;
		this.icon = icon;
		this.data = data;
		this.insl=insl;
		this.insr=insr;
		this.inst=inst;
		this.insb=insb;
		this.light = light;
	}
	Block() {
		solid = true;
		icon = Lib.icons.byBlock(this);
		data = 0;
		insl=0;
		insr=0;
		inst=0;
		insb=0;
		light=0D;
	}
	Block(int data) { this(); this.data = data; }
	
	public GSnip getIcon() {
		return icon;
	}
	
	public boolean isSolid() {
		return solid;
	}
	
	public int getData() { return data; }
	public void setData(int data) { this.data = data; }
	
	public String toString() {
		String ret;
		
		switch(this) {
		case stone:			ret = "stone"; break;
		case player:		ret = "player"; break;
		case dirt:			ret = "dirt"; break;
		default:			ret = "air";
		}
		
		if (data == 0) return ret;
		else           return ret+":"+data;
	}
	
	public String encode() { // TODO "4E 55 4D 42   44 41 54 41" (without spaces)
		String type = Integer.toHexString(this.ordinal());
		String retype = "";
		
		
		return Integer.toHexString(this.ordinal()) + Integer.toHexString(data);
	}
	public static Block decode(String wut) {
		return null; // TODO decode blocks from previously encoded strings
		
	}
	
}
package model;

/**A wrapper for a block giving it x/y coords and the Chunk*/
public class BlockX {
	private final Block original;
	
	private Chunk chunk;
	private double x, y;
	
	public BlockX(Block original) {
		this.original = original;
	}
	public BlockX(Block original, double x, double y) {
		this(original);
		this.x = x;
		this.y = y;
	}
	public BlockX(Block original, Chunk chunk) { this(original); this.chunk = chunk; }
	public BlockX(Block original, double x, double y, Chunk chunk) { this(original, x, y); this.chunk = chunk; } 
	
	public void setChunk(Chunk chunk) { this.chunk = chunk; }
	public Chunk getChunk() { return chunk; }
	public void setX(double x) { this.x = x; }
	public void setY(double y) { this.y = y; }
	public double getX() { return x; }
	public double getY() { return y; }
	public void setPos(double x, double y) { this.x = x; this.y = y; }
	public Block getOrig() { return original; }
}
package model;

import java.util.LinkedList;
import java.util.List;

import mutil.Avoid;

public class Chunk {
	public static final int cs = 64; // Chunksize 64x64
	
	Block[][] data;
	public final int x, y; // 0:1st chunk. 1:second chunk. (not 64:second chunk)
	public World world; // in which world am i ?
	
	List<Entity> entities;
	
	public Chunk(World world, int x, int y) {
		this.world = world;
		this.x = x;
		this.y = y;
		data = new Block[cs][cs];
		for (int mx=0; mx<cs; mx++) for (int my=0; my<cs; my++) data[mx][my] = Block.air;
		
		entities = new LinkedList<Entity>();
	}
	
	public int getWorldPosX() { return x*cs; }
	public int getWorldPosY() { return y*cs; }
	public @Deprecated int getPosX() { return x; }
	public @Deprecated int getPosY() { return y; }
	
	public @Avoid("") World getWorld() { return world; }
	
	public void entityadd(Entity e) { entities.add(e); }
	public void entityrem(long eid) { for (Entity e : entities) { if (e.eid==eid){entities.remove(e);return;}} }
	public void entityrem(Entity e) { entities.remove(e); }
	
	public Block getr(int x, int y)
	{
		if (x>=0 && y>=0 && x<cs && y<cs)
		{
			return data[x][y];
		}else
		{
			return Block.air;
		}
	}
	public Block geta(int x, int y)
	{
		if (x>=(this.x*cs) && y>=(this.y*cs) && x<(this.x*cs)+cs && y<(this.y*cs)+cs )
		{
			return data[x%cs][y%cs];
		} else return Block.air;
	}
	
	public void setr(int x, int y, Block data)
	{
		if (x>=0 && y>=0 && x<cs && y<cs)
		{
			this.data[x][y] = data;
		}
	}
	public void seta(int x, int y, Block data)
	{
		if (x>=(this.x*cs) && y>=(this.y*cs) && x<(this.x*cs)+cs && y<(this.y*cs)+cs)
		{
			this.data[x-(this.x*cs)][y-(this.y*cs)] = data;
		} else return;
	}
	
}
package model;

public class Entity {
	protected double x, y; // finer calculations only with entities
	protected final long eid; // entitiy global ID
	protected Chunk chunk; // in which chunk am i ?
	protected final World world;
	
	public Entity(World in, double x, double y) {
		if (in == null) { throw new IllegalArgumentException("(World)in must not be null."); }
		this.x = x;
		this.y = y;
		this.chunk = in.ensureChunkAt((int)x, (int)y);
		this.world = in;
		this.eid = in.entityallocate(this);
	}
	
	public double getX() { return x; }
	public double getY() { return y; }
	
	public void update(double delta) { }
	
	public void destroyme() { if (world != null) world.entitykill(eid); else chunk.getWorld().entitykill(eid); }
	
	public World getWorld() { return world; }
	public Chunk getChunk() { return chunk; }
	public long getEID() { return eid; }
	
	public void move(double x, double y) {
		Chunk nc = chunk.getWorld().ensureChunkAt((int)x, (int)y);
		this.x = x; this.y = y;
		if (nc == chunk) return;
		chunk.entityrem(this);
		nc.entityadd(this);
		System.out.printf("Entity #%d: from %s to %s\n", eid, chunk, nc);
		
		chunk = nc;
	}
}
package model;

public class EntityMonster extends Entity {
	
	int hp, maxhp;
	
	public EntityMonster(World in, double x, double y) {
		super(in, x, y);
		maxhp = 20;
		hp = maxhp;
	}

	
	
}
package model;

import java.awt.Color;

import view.GraphicsEngine;
import mutil.*;

/**
 * 
 * pickup() return codes:
 * 0/positive: okay. (index of slot)
 * -1[egative]: error.
 */

public class EntityPlayer extends Entity {
	private double dir, speed;
	private int hp,maxhp;
	private int exp,maxexp;
	private int level;
	private Inventory inv;
	private Inventory palette;
	private Inventory armor;
	
	public EntityPlayer(World in, double x, double y) {
		super(in, x, y);
		levelup(1);
		inv     = new Inventory(8*4);
		palette = new Inventory(8*1);
		armor   = new Inventory(4*1);
	}
	
	public Inventory getInv() { return inv; }
	public Inventory getPalette() { return palette; }
	public Inventory getArmor() { return armor; }
	
	public int pickup(Entity wut) {
		
		return 0;
	}
	
	public void die() {
		System.out.printf("WORLD [Entity %d] (EntityPlayer) died!\n", eid);
		destroyme();
	}
	
	public void levelup(int levelnew) {
		level = levelnew;
		
		maxexp = 70+20*(level-1);
		exp    = 1;
		maxhp  = 100+10*(level-1);
		hp+=maxhp/10; if(hp>maxhp)hp=maxhp;
	}
	public int hurt(int ouchies) { this.hp-=ouchies; if(hp<0){hp=0; die();} return hp; }
	public int getHP() { return hp; }
	public int getMaxHP() { return maxhp; }
	public double getHPRatio() { return (double)maxhp/(double)hp; }
	public int getExp() { return exp; }
	public int getMaxExp() { return maxexp; }
	public double getExpRatio() { return (double)exp/(double)maxexp; }
	public int getLevel() { return level; }
	
	@Override
	public void move(double x, double y) {
		super.move(x, y);
		Block b = world.get((int)x, (int)y);
		if (!b.isSolid()) return;
		if (palette.push(b)<0) return;
		world.set((int)x, (int)y, Block.air);
	}
	
	@Override
	public @Undone void update(double delta) {
		x += Math.cos(dir)*speed*delta;
		y += Math.sin(dir)*speed*delta;
	}

}
package model;

public class EntityProjectile extends Entity {

	private double dir, speed;
	
	public EntityProjectile(World in, long eid, double x, double y) {
		super(in, x, y);
	}
	
	@Override
	public void update(double delta) {
		double px=x, py=y;
		
		x += (float)(Math.cos(dir)*speed*delta);
		y += (float)(Math.sin(dir)*speed*delta);
		
		
	}
	
}
package model;

import java.util.Queue;

public @SuppressWarnings("rawtypes") class Inventory {
	InventorySlot[] slots;
	
	public Inventory(int amount) {
		slots = new InventorySlot[amount];
		
	}
	
	public InventorySlot get(int slot) {
		if (slot <0 || slot >= slots.length) return null;
		return slots[slot];
	}
	
	public int push(Object wut) {
		for (int i=0; i<slots.length; i++) {
			InventorySlot s = slots[i];
			if (s == null)           { s = (slots[i] = new InventorySlot(wut)); return i; }
			if (s.isCompatible(wut)) { if (s.push(wut))                         return i; }
			if (s.isEmpty())         { s = (slots[i] = new InventorySlot(wut)); return i; } // if (s.isEmtpy()) { slots[i] = null; i--; continue; }
		}
		return -1;
	}
	public int pushto(Object wut, int slot) {
		if (slot < 0 || slot >= slots.length) return -1;
		
		InventorySlot s = slots[slot];
		if (s == null)           { slots[slot] = new InventorySlot(wut); return slot; }
		if (s.isCompatible(wut)) { if (s.push(wut))                      return slot; }
		if (s.isEmpty())         { slots[slot] = new InventorySlot(wut); return slot; }
		
		return -1;
	}
	public Object popfrom(int slot) {
		if (slot < 0 || slot >= slots.length) return null;
		
		InventorySlot s = slots[slot];
		if (s == null) return null;
		return s.pop();
	}
	public Object peekfrom(int slot) {
		if (slot < 0 || slot >= slots.length) return null;

		InventorySlot s = slots[slot];
		if (s == null) return null;
		return s.peek();
	}
}
package model;

import java.util.*;

import view.GSnip;

public class InventorySlot {
	public static final int ss = 64; // max. stacksize
	
	private Object[] list;
	private final Class<? extends Object> type;
	private boolean isempty;
	private int quantity;
	private final GSnip icon;
	
	public InventorySlot(Object first) {
		if (first instanceof Block) icon = Lib.icons.byBlock((Block)first);
		else if (first instanceof Entity) icon = Lib.icons.byEntity((Entity)first);
		else throw new IllegalArgumentException("(Object)first must be instaceof Block or Entity.");
		
		list = new Object[ss];
		this.type = first.getClass();
		list[0] = first;
		isempty = false;
		quantity = 1;
	}
	
	public GSnip getIcon() { return icon; }
	public boolean isCompatible(Object wut) { if (wut.getClass().equals(this.type)) return true; else return false; }
	public boolean push(Object wut) {
		if (!isCompatible(wut)) return false;
		
		for (int i=0; i<ss; i++) {
			if (list[i] == null) {
				list[i] = wut;
				quantity++;
				return true;
			}
		}
		
		isempty = false;
		return false;
	}
	public Object  pop() {
		for (int i=0; i<ss; i++) {
			if (list[i] != null) {
				Object ret = list[i];
				list[i] = null;
				if (i==ss-1) isempty=true;
				
				quantity--;
				return ret;
			}
		}
		isempty = true;
		return null;
	}
	public Object  peek() {
		for (int i=0; i<ss; i++) if (list[i] != null) return list[i];
		
		isempty=true;
		return null;
	}
	public boolean isEmpty() { return isempty; }
	public int getQuantity() { return quantity; }
}
package model;

public abstract class Lib {
	public static final LibIcons icons = new LibIcons("icons.png");
}
package model;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.ImageIO;

import view.GSnip;

// loads block-icons and entity-icons
// to display them in the inventory

public class LibIcons {
	public static final int iconsize = 24;
	public static final int ipr = 16; // icons per row: 16*16 = 256 images
	
	private final GSnip[] data;
	
	LibIcons(String filename) {
		data = new GSnip[ipr*ipr];
		
		Color alphakey = new Color(255,0,255); // fuchsia
		Color transparent = new Color(0,0,0,0);
		
		BufferedImage img = null;
		try {
			img = ImageIO.read(new File(new File(".").getCanonicalPath() + "/" + filename));
			for (int x=0; x<ipr; x++) {
				for (int y=0; y<ipr; y++) {
					GSnip gs = new GSnip(iconsize, iconsize);

					for (int mx=0; mx<iconsize; mx++) {
						for (int my=0; my<iconsize; my++) {
							Color c = new Color(img.getRGB(mx+x*iconsize, my+y*iconsize));
							if (c.equals(alphakey)) c = transparent;
							gs.setraw(mx, my, c);
						}
					}

					data[x+y*ipr] = gs;
				}
			}
		}catch(Exception ex) { System.out.printf("CORE [Model.Lib  Icons] Failed to load icons from %s\n", filename); }

	}
	
	public GSnip byEntity(Entity e) {
		return data[1]; // TODO real specification via "e instaceof EntityPlayer,EntityProjectile,EntityWuteva"
	}
	
	public GSnip byBlock(Block b) {
		return data[0]; // TODO real specification via switch(b)
	}
	
	public GSnip byIndex(int index) {
		if (index < 0 || index >= ipr*ipr) return data[0];
		return data[index];
	}
}
package model;

import java.awt.image.BufferedImage;
import java.io.*;
import java.util.HashMap;
import java.util.List;
import java.util.LinkedList;
import java.util.Vector;

import javax.imageio.ImageIO;

import view.Compiz;
import view.GraphicsEngine;
import view.Snippet;
import view.GSnip;
import view.View;
import view.gui.WindowManager;

import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import java.util.Stack;

public class Model {
	
	public Model() {
		propertifies     = new HashMap<String, Object>(100);
		compizsnippets   = new LinkedList<Snippet>();
		wm               = new WindowManager();
		world            = new World();
		player           = new EntityPlayer(world, 0,0);
		System.out.printf("CORE INIT [model.Model this(..) news] (EntityPlayer)player.eid = %d\n", player.getEID());
		
		BufferedImage img = null;
		try {
			img = ImageIO.read(new File(new File(".").getCanonicalPath() + "/worldfix_map_110529.bmp"));
			for (int x=0; x<img.getWidth(); x++) {
				for (int y=0; y<img.getHeight(); y++) {
					if (img.getRGB(x, y) != -1) world.set(x, y, Block.stone);
					else                        world.set(x, y, Block.air);
				}
			}
		} catch (Exception ex) { System.out.println("Model.this(): couldnt load map"); }
		
		termtext = new Vector<String>();
	}
	
	/**e.g. "bobs save" ((--> "./bobs save.sav") */
	public void save(String savename) {
		try {/* serialisation: sux
			FileOutputStream fout = new FileOutputStream(savename+".sav");
			ObjectOutputStream oos = new ObjectOutputStream(fout);
			oos.writeObject(this);
			oos.close();*/
			
			FileWriter fw = new FileWriter(savename+".sav");
			BufferedWriter out = new BufferedWriter(fw);
			
			for (int x=0; x<View.WIDTH; x++) {
				for (int y=0; y<View.HEIGHT; y++) {
					Block b = world.get(x,y);
					if (b==null || b == Block.air) { out.write(" "); continue; }
					System.out.println(b.toString());
					out.write(b.toString());
				}
				out.write('\n');
			}
			
			// end of map data
			out.write('\n');
			out.write('\n');
			
			// todo: entities
			/* 110629: commented out: minecraftification
			for (Block b : enten) {
				out.write(p.toString());
			}
			*/
			
			out.write("\n");
			
			out.close();
		} catch (Exception e) { return; }
	}
	
	World world;
	public World getWorld() { return world; }
	
	// MG: michal gamrat && maze generation
	int roomsInLine = 19;
	int roomsCount = roomsInLine * roomsInLine;
	Room[][] rooms;
	Stack<Point> recentRooms;
	Point currentRoomCoord;
	public void createMaze() {

		currentRoomCoord = new Point(0, 0);

		int x, y;

		rooms = new Room[roomsInLine][roomsInLine];

		for(x=0; x<roomsInLine; x++){
			for(y=0; y<roomsInLine; y++){
				rooms[x][y] = new Room();    
			}   
		}


		recentRooms = new Stack<Point>();

		this.goToNextRoom();

		while(recentRooms.empty() == false){
			this.goToNextRoom();
		} 

		int roomWidth = View.WIDTH / roomsInLine;
		int roomHeight = View.HEIGHT / roomsInLine;

		int rx, ry, x_offset, y_offset;

		for(y=0; y<roomsInLine; y++){
			for(x=0; x<roomsInLine; x++){
				//System.out.print(rooms[y][x].toString());

				y_offset = y * roomHeight;
				x_offset = x * roomWidth;

				Room r = rooms[y][x];
				Block b;

				for(ry=0; ry<roomHeight; ry++){
					for(rx=0; rx<roomWidth; rx++){
						if(ry < 3 && r.n || ry > roomHeight-3 && r.s || rx<3 && r.w || rx>roomWidth-3 && r.e ){      
							b = Block.stone;
							world.set(rx + x_offset, ry + y_offset, b);
						}else{       
							//map[rx + x_offset][ry + y_offset] = null;
							world.set(x_offset+rx, y_offset+ry, Block.air);
							//this.set(rx + x_offset, ry + y_offset, null);      
						}

					}
				}    

			}
			//System.out.println();
		}


	}
	private Set getRooms(){

		Set r = new HashSet();

		if(currentRoomCoord.y > 0 && rooms[(int) currentRoomCoord.y - 1][(int) currentRoomCoord.x].visited == false){
			r.add(1);
		}

		if(currentRoomCoord.y < roomsInLine - 1 && rooms[(int) currentRoomCoord.y + 1][(int) currentRoomCoord.x].visited == false){
			r.add(2);
		}

		if(currentRoomCoord.x > 0 && rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x - 1].visited == false){
			r.add(3);
		}

		if(currentRoomCoord.x < roomsInLine - 1 && rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x + 1].visited == false){
			r.add(4);
		}

		return r;

	}
	private void goToPrevRoom(){

		Point p = recentRooms.pop();
		currentRoomCoord.x = p.x;
		currentRoomCoord.y = p.y;

	}
	private void goToNextRoom(){

		//System.out.println("Current room: "+currentRoom.toString());

		Set r = this.getRooms();

		if(r.isEmpty()){
			goToPrevRoom();
			return;
		}

		recentRooms.push(new Point(currentRoomCoord.x, currentRoomCoord.y));

		rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].visited = true;

		Random randomGenerator = new Random();  
		int randomInt = randomGenerator.nextInt(r.size());  

		int dir = (Integer)r.toArray()[randomInt];

		rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].visited = true;

		switch(dir){
		case 1:   
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].n = false;
			currentRoomCoord.y -= 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].s = false;
			break;
		case 2:
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].s = false;
			currentRoomCoord.y += 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].n = false;
			break;
		case 3:
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].w = false;
			currentRoomCoord.x -= 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].e = false;
			break;
		case 4:
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].e = false;
			currentRoomCoord.x += 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].w = false;
			break;
		}

		rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].visited = true;

	}
	
	public GSnip getImg(String fortype) {
		
		try {
			BufferedImage img = ImageIO.read(new File(new File(".").getCanonicalPath()+"/"+fortype+".bmp"));
		} catch (IOException e) {
			System.out.println("[model.getImg(..)] Image not found for type \""+fortype+"\"");
			return null;
		}

		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////yay/////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		
		return null;
	}
	
	// PROCESSING
	// huh :o? @see World / Chunk / Entity for raytracing
	
	// PROPERTIFY
	private HashMap<String, Object> propertifies;
	public void propset(String key, Object value) { propertifies.put(key, value); }
	public Object prop(String key) { return propertifies.get(key); }
	
	// VARIOUS RESSOURCES
	
	private WindowManager wm;
	public WindowManager getWM() { return wm; }
	
	// Map scrolling
	double offx, offy; // how many BLOCKS(Model.zoom). The post-comma part is pixels (may be buggy of course)
	double noffx, noffy;
	public final static int zoom = 10; // blocksize (if zoom==1 then offx/y could be int)
	public synchronized void scrollToCentrify(double x, double y) {
		noffx = x-(View.WIDTH /zoom/2); // TODO centrify realy
		noffy = y-(View.HEIGHT/zoom/2);
	}
	public synchronized void scrollTo(double x, double y) {
		noffx = x;
		noffy = y;
	}
	public void setScrolls() { this.offx = noffx; this.offy = noffy; }
	public double scrollX() { return offx; }
	public double scrollY() { return offy; }
	
	// Compiz
	private List<Snippet> compizsnippets;
	private Compiz compiz;
	
	// TODO buggy (lazy initialisation of compiz)
	public @Deprecated Compiz compizEnsure(Compiz cpz) {
		if (this.compiz != null) this.compiz = cpz;
		return compiz;
	}
	public @Deprecated Compiz compizEnsure(GraphicsEngine ge) {
		if (this.compiz == null) return (this.compiz = new Compiz(ge));
		return compiz;
	}

	/*
	 * If you arent sure if compiz yet has been created. you might use compizEnsure (the one taking GraphicsEngine).
	 * They're very handy. [[[> WARNING: as of my new Standard v0.11R10IN this is deprecated. init*() are now in use! <]]] 
	 * @return Compiz. NULL otherwise. (otherwise use compizEnsure(..));
	 */
	public Compiz compizGet() { return compiz; }
	public List<Snippet> compizSnippetsGet() {
		return compizsnippets;
	}
	public @Deprecated void compizSnippetsAdd(Snippet snip) {
		compizsnippets.add(snip);
	}
	public void compizSnippetsRemove(Snippet snip) {
		compizsnippets.remove(snip);
	}
	
	// pausing
	private boolean paused = false;
	
	public void pause(boolean p) { this.paused = p; }
	public boolean pause() { return paused; }
	
	// data
	private EntityPlayer player;
	public EntityPlayer getPlayer() { return player; }
	
	// terminal (WIP)
	private Vector<String> termtext;
	private boolean termextend = false; // fullscreen terminal
	
	public Vector<String> termGetText() { return termtext; }
	public void termPost(String text) { termtext.add(text); if (termtext.size() < 6) return; termtext.remove(0); }
	public String termLast(int neg) { int npos=termtext.size()-neg-1; if (npos<0 || npos>=termtext.size()) return null; return termtext.get(npos); }
	public boolean termExtend() { return termextend; }
	public void termExtend(boolean termextend) { this.termextend = termextend; }
	
	// form((forms are deprecated. Windows/containers)) managment (see getWM() and WindowManager in view.gui )
	private boolean useforms = false;

	public boolean useForms() {
		return useforms;
	}
	public void useForms(boolean useforms) {
		this.useforms = useforms;
	}
	
}
package model;

public class Point {
	public float x, y;
	
	
	public Point(float x, float y) {
		this.x = x;
		this.y = y;
	}
	
	public String toString(){
		return "x: " + Float.toString(x) + ", y: " + Float.toString(y);
	}
}
package model;


public class Room {
	public boolean n, s, e, w, visited;

	public Room(){
		n = s = e = w = true;
		visited = false;
	}

	public String toString(){

		String dir = "[";

		if(!n){
			dir += "1";
		}

		if(!s){
			dir += "2";   
		}

		if(!w){
			dir += "3";
		}

		if(!e){
			dir += "4";
		}

		dir += "]";

		return dir;  

	}

}package model;

import java.util.LinkedList;
import java.util.List;

import mutil.Undone;

/*
 * COORD MODIFIERS:
 * absolute / relative
 * normal / chunkish
 * 
 * a	absolute: from world's zero
 * r	relative: from current chunk's zero
 * 
 * -	normal: in block coords context
 * ch	chunkish: in chunk coords context
 * `-> (chunkish*cs) == normal
 * `-> (Math.floor(normal/cs) == chunkish)
 * 
 */

public class World {
	private static final int cs = Chunk.cs;
	
	List<Chunk> chunks; // all the chunks
	Entity[] entities; // global entities storer
	
	public World() {
		chunks = new LinkedList<Chunk>();
		entities = new Entity[65536];
	}
	
	
	
	public @Deprecated void makeChunk(int chx, int chy) {
		Chunk c = new Chunk(this, chx, chy);
		chunks.add(c);
	}
	
	/**ret[1]: wall. ret[0]: last okay position*/
	public @Undone BlockX[] raytrace(double x1, double y1, double x2, double y2) {
		float len = (float) Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
		if ( len == 0 ) {
			//TODO: Make this function stop if this happens.
			return null;
		}

		double addx = (x2 - x1)/len;
		double addy = (y2 - y1)/len;

		while (((int) x1 != (int) x2 || (int) y1 != (int) y2) && (addx < 0 ? x1 >= x2 : x1 <= x2) && (addy < 0 ? y1 >= y2 : y1 <= y2)) {
			x1 += addx;
			y1 += addy;

			Block b = get((int)Math.round(x1), (int)Math.round(y1));
			if (b == null || b == Block.air) continue;
			//more emptiness conditions

			BlockX[] ret = new BlockX[2];
			
			BlockX prev = new BlockX(Block.air, x1-addx, y1-addy);
			BlockX curr = new BlockX(null);
			ret[1] = new BlockX(b); // the wall
			if (prev != null) { 
				ret[0] = new BlockX(null); // TODO ask evan
			} else {
				ret[0] = new BlockX(Block.air, x1-addx, y1-addy); // yay
			}
			return ret;
		}

		return null;

	}
	
	public long entityallocate(Entity ente) {
		for (int i=0; i<entities.length; i++) {
			if (entities[i] == null) {
				entities[i] = ente;
				System.out.printf("WORLD [Entity %d] Allocated EID for %s\n", i, ente);
				return i;
			}
		}
		System.out.printf("WORLD [Entity -1] Failed to allocate EID for %s\n", ente);
		return -1;
	}
	public void entitykill(long eid) {
		if (eid>=0 && eid<entities.length)  {
			Entity e = entities[(int) eid];
			if (e == null) { System.out.printf("WORLD [Entity %d] Failed to kill Entity by EID (Slot already null)\n", eid); return; }
			
			entities[(int) eid] = null;
			Chunk c; (c = e.getChunk()).entityrem(eid);
			System.out.printf("WORLD [Entity %d] Killed %s from %s\n", e, c);
		}
		System.out.printf("WORLD [Entity %d] Failed to kill Entity by EID (Out of range)\n", eid);
	}
	public void entitiesUpdate(double delta) {
		for (Entity e : entities) {
			if (e != null) e.update(delta);
		}
	}
	
	
	public Block get(int x, int y) {
		Chunk c = getChunkAt(x,y);
		if (c != null) { return c.geta(x, y); }
		return Block.air;
	}
	public void set(int x, int y, Block datatype) { Chunk c = ensureChunkAt(x,y); c.seta(x, y, datatype); }
	
	public Chunk ensureChunkAt(int x, int y) {
		//for (Chunk c : chunks) if (x>=c.x*cs && y>=c.y*cs && x<(c.x+1)*cs && y<(c.y+1)*cs) return c;
		Chunk c = getChunkAt(x, y);
		if (c != null) return c;
		
		c = new Chunk(this, (int)Math.floor(x/cs), (int)Math.floor(y/cs));
		chunks.add(c);
		return c;
	}
	public Chunk getChunkAt(int x, int y) {
		for (Chunk c : chunks) if (x>=c.x*cs && y>=c.y*cs && x<(c.x+1)*cs && y<(c.y+1)*cs) return c;
		return null;
	}
	public Chunk getChunk(int chx, int chy) {
		for (Chunk c : chunks) if (chx == c.x && chy == c.y) return c;
		return null;
	}
}




package mutil;

public @interface Avoid {
	public String value();
}
package mutil;

// optimizing it for forms

/**DONT USE IT! COOKIES _WILL_ SHOOT AT YA.*/
public @Deprecated class LinkedList<T> {
	class Node<TT> {
		public TT value;
		public Node<TT> next, prev;
		
		public Node(TT value) { this.value = value; }
	}
	
	private Node<T> begin, end;
	
	public LinkedList() {
		begin = new Node<T>(null); // dummy
		begin.next = null;
		begin.prev = null;
		begin.value = null;
		end = begin;
	}
	
	public void bringtop(T wut) {
		Node<T> cur = begin;
		while ((cur=cur.next) != null) {
			if (cur.value == wut) {
				
				// cut
				cur.prev.next = cur.next;
				cur.next.prev = cur.prev;
				
				// paste
				cur.next = null;
				cur.prev = end;
				end.next = cur;
				
				break;
			}
		}
	}
	
	public void delete(T wut) {
		Node<T> cur = begin;
		while ((cur=cur.next) != null) {
			if (cur.value == wut) {
				cur.prev.next = cur.next;
				cur.next.prev = cur.prev;
			}
		}
	}
	
	public void stackpush(T wut) {
		end.next = new Node<T>(wut);
		end.next.prev = end;
		end = end.next;
	}
	public T stackpop() {
		T ret = end.value;
		
		if (end.prev != null) {
			end.prev.next = null;
			end = end.prev;
		} // else { nothing }; // because in that case end == begin
		
		return ret;
	}
	
	public T stacktop() { return end.value; }
}











package mutil;

public @interface Undone { }
package startup;

import gol.*;
import model.*;
import view.*;

/*  C O N T R O L L E R
 *        V i e w
 *         Model
 */

public class Startup {
	
	private static View view = null;
	private static Model model = null;
	private static GoL controller = null;
	
	public static void main(String[] args) {
		model = new Model();
		view = new View(model);
		
		controller = new GoL();
		
		view.start();
		
	}
}
package view;

import java.awt.Color;
import java.util.*;

public class Compiz {
	private float[][] mymap;
	private GraphicsEngine ge;
	private boolean needremap = false;
	
	public Compiz(GraphicsEngine ge) {
		this.ge = ge;
		//mymap = new float[GraphicsEngine.WIDTH][GraphicsEngine.HEIGHT];
		//remap();
	}
	
	public GraphicsEngine getGE() { return ge; }
	/**
	 * So that Pixies can access the add method easier.
	 * Don't forget to call remap() later !
	 * @param snip Snippet to be added to the list.
	 */
	public void snippetsAdd(Snippet snip) {
		ge.getModel().compizSnippetsAdd(snip);
		needremap = true;
	}
	/**
	 * 
	 * @param snippet
	 */
	public void snippetsRemove(Snippet snip) {
		ge.getModel().compizSnippetsRemove(snip);
		needremap = true;
	}
	
	public boolean needRemap() { return needremap; }
	public void needRemap(boolean needremap) { this.needremap = needremap; }
	public void remap() {
		/*
		System.out.print("[view.Compiz.remap()] Remapping alpha values..");
		long prevtime = System.currentTimeMillis();
		List<Snippet> snippets = ge.getModel().compizSnippetsGet();
		
		
		// clear values
		for (int x=0; x<ge.WIDTH; x++) {
			for (int y=0; y<ge.HEIGHT; y++) {
				mymap[x][y] = 0;
			}
		}
		
		// recalculate
		try {
			for (int i=0; i<snippets.size(); i++) {
				Snippet that = snippets.get(i);
				for (int x=0; x<that.getSizeX(); x++) {
					for (int y=0; y<that.getSizeY(); y++) {
						mymap[x+that.x][y+that.y] += that.gethard(x, y);
					}
				}
			}
		} catch (Exception ex) { System.out.println("BLAH"); }
		
		needremap = false;
		System.out.println(" "+(System.currentTimeMillis()-prevtime)+"ms");
		*/
	}

	public void blend() {
		/*
		if (needremap) remap();
		
		for (int x=0; x<ge.WIDTH; x++) {
			for (int y=0; y<ge.HEIGHT; y++) {
				//if (mymap[x][y] == 0) continue;
				
				Color c = ge.get(x, y);
				float r=c.getRed()/255.0f,g=c.getGreen()/255.0f,b=c.getBlue()/255.0f;
				
				r += mymap[x][y];
				g += mymap[x][y];
				b += mymap[x][y];
				
				if (r<0)r=0; if (r>1)r=1;
				if (g<0)g=0; if (g>1)g=1;
				if (b<0)b=0; if (b>1)b=1;
				
				ge.set(x, y, new Color(r,g,b));
			}
		}
		*/
	}
}
















package view;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

import javax.swing.*;

import view.gui.Container;

import model.Model;

@SuppressWarnings("serial")
public class GraphicsEngine extends JFrame implements Runnable, MouseMotionListener, MouseListener, KeyListener {
	public static final int WIDTH=840, HEIGHT=480; // canvas sizes
	protected static final Color clearcolor = Color.black;

	protected int insl, insr, inst, insb;
	protected BufferedImage canvas;
	protected Graphics2D g2d;
	protected boolean initialized = false; // true when initialization complete...
	
	private long lasttime;
	private int framedelay = 10; // ms
	protected float delta;
	
	protected Model model;
	
	protected Vector<FrameUpdateL> frameupdatelisteners;
	protected Vector<MouseMotionL> mousemotionlisteners;
	protected Vector<MouseL> mouselisteners;
	protected Vector<KeyL> keylisteners;

	public interface MouseL {
		public boolean mouseClicked(int x, int y);
	}
	public interface MouseMotionL {
		public boolean mouseMoved(int x, int y);
		public boolean mouseDragged(int x, int y);
		public boolean mouseDown(int x, int y);
		public boolean mouseUp(int x, int y);
	}
	public interface KeyL {
		public boolean keyTyped(char letter);
		public boolean keyPressed(int i);
	}
	public interface FrameUpdateL {
		public void updateFrame(float delta);
	}
	
	public void addMouseMotionL(MouseMotionL l) {
		mousemotionlisteners.add(l);
	}
	public void addMouseL(MouseL l) {
		mouselisteners.add(l);
	}
	public void addKeyL(KeyL l) {
		keylisteners.add(l);
	}
	public void addFrameUpdateL(FrameUpdateL l) {
		frameupdatelisteners.add(l);
	}
	void invokeFrameUpdateListeners() {
		for (FrameUpdateL l : frameupdatelisteners) {
			l.updateFrame(delta);
		}
	}
	
	// blending
	
	
	public static Color blendLight(Color col, float light) {
		int r = col.getRed();
		int g = col.getGreen();
		int b = col.getBlue();

		float rat = 1;

		if ( light < 0.5f ) {
			rat = (0.5f - light)/0.5f;
			r = r+ (int)((0f - (float)r)*rat);
			g = g+ (int)((0f - (float)g)*rat);
			b = b+ (int)((0f - (float)b)*rat);
		} else if ( light > 0.5f ) {
			rat = (light - 0.5f)/0.5f;
			r = r + (int)((255 - (float)r)*rat);
			g = g + (int)((255 - (float)g)*rat);
			b = b + (int)((255 - (float)b)*rat);
		}

		if (r>255) r = 255; if (r<0) r=0;
		if (g>255) g = 255; if (g<0) g=0;
		if (b>255) b = 255; if (b<0) b=0;
		
		return new Color(r, g, b);
	}
	public static int blendLight(int rgb, float light)
	{
		return rgb;
	}
	public static Color blend(Color backg, Color foreg) { // foreg's Alpha
		if (foreg == null || foreg.getAlpha() == 0) return backg;
		if (foreg.getAlpha() == 255 || backg == null) return foreg;
		
		int r = backg.getRed();
		int g = backg.getGreen();
		int b = backg.getBlue();
		float a = (255-foreg.getAlpha())/255f;
		
		r = (int)(r*a + foreg.getRed()*(1-a));
		g = (int)(g*a + foreg.getGreen()*(1-a));
		b = (int)(b*a + foreg.getBlue()*(1-a));
		
		//if (backg.getAlpha() != 255) System.out.println("[view.GraphicsEngine blend(..)]true: backg.getAlpha() != 255");
		return new Color(r,g,b, 255);
		//return new Color(r,g,b, backg.getAlpha());
	}
	public static Color blenda(Color backg, Color foreg) { // foreg's Alpha
		if (foreg == null || foreg.getAlpha() == 0) return backg;
		if (foreg.getAlpha() == 255 || backg == null) return foreg;
		
		int r = backg.getRed();
		int g = backg.getGreen();
		int b = backg.getBlue();
		float a = (255-foreg.getAlpha())/255f;
		
		r = (int)(r*a + foreg.getRed()*(1-a));
		g = (int)(g*a + foreg.getGreen()*(1-a));
		b = (int)(b*a + foreg.getBlue()*(1-a));
		
		//if (backg.getAlpha() != 255) System.out.println("[view.GraphicsEngine blend(..)]true: backg.getAlpha() != 255");
		return new Color(r,g,b, backg.getAlpha());
		//return new Color(r,g,b, backg.getAlpha());
	}
	
	// continue with usual stuff
	
	protected synchronized void onUpdate() { }
	protected synchronized void onRender() { } // PLASE put a syncrhonized over canvas because of reRender!
	
	public GraphicsEngine(Model model) {
		super();
		initialized = false;
		this.model = model;
		
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		
		frameupdatelisteners = new Vector<FrameUpdateL>();
		mousemotionlisteners = new Vector<MouseMotionL>();
		mouselisteners = new Vector<MouseL>();
		keylisteners = new Vector<KeyL>();
		
		lasttime = System.currentTimeMillis();
	}

	
	public void set(int x, int y, Color cl) {
		if (x<0 || y<0 || x>=WIDTH || y>=HEIGHT) return;
		if (cl == null) return;
		canvas.setRGB(x, y, cl.getRGB());
	}
	public void seta(int x, int y, Color cl) {
		if (x<0 || y<0 || x>=WIDTH || y>=HEIGHT) return;
		if (cl == null) return;
		canvas.setRGB(x, y, (blend(get(x,y), cl)).getRGB());
	}
	public void setrgb(int x, int y, int rgb) {
		if (x<0 || y<0 || x>=WIDTH || y>=HEIGHT) return;
		canvas.setRGB(x, y, rgb);
	}
	public Color get(int x, int y) {
		if (x<0 || y<0 || x>=WIDTH || y>=HEIGHT) return clearcolor;
		return new Color(canvas.getRGB(x, y));
	}
	public int getrgb(int x, int y) {
		if (x<0 || y<0 || x>=WIDTH || y>=HEIGHT) return clearcolor.getRGB();
		return canvas.getRGB(x, y);
	}
	
	public Model getModel() { return model; }
	
	public void reRender() {
		//onRender(); TODO
	}
	
	public void paint(Graphics g) {
		if (!initialized) { System.out.println("GE/repaint: Not yet initialzed!"); return; }
		if (canvas == null) { System.out.println("GE/repaint: Canvas is null!"); return; }
		
		/*
		g.setColor(new Color(0,0,0, 10));
		g.fillRect(insl, insr, WIDTH+insl, HEIGHT+inst );
		*/
		/*
		for (int x=0; x<WIDTH; x++) {
			for (int y=0; y<HEIGHT; y++) {
				canvas.setRGB(x, y, canvas.getRGB(x, y));
			}
		}
		*/
		g.drawImage(canvas, insl, inst, WIDTH+insl, HEIGHT+inst, 0, 0, WIDTH, HEIGHT, null);
	}
	public void run() {
		while (true) {
			long millis = System.currentTimeMillis();
			float diff = millis - lasttime;
			
			if (diff > framedelay) {

				delta = diff / 1000f; // ms -> s
				onUpdate();

				g2d.setColor(clearcolor);
				//System.out.println("GE.run.canvas.width: "+canvas.getWidth() + "| .height: " + canvas.getHeight());
				g2d.fillRect(0, 0, canvas.getWidth(), canvas.getHeight());
				onRender();
				repaint();
				
				lasttime = System.currentTimeMillis();
			} else {
				long sleeptime = (long) (framedelay - diff);
				try {
					Thread.currentThread().sleep(sleeptime);
				} catch (Exception ex) {
					ex.printStackTrace();
					System.out.println("Couldnt sleep!");
				}
			}
		}
		
		/*
		while (initialized) {
			float diff = System.currentTimeMillis() - lasttime;
			if (diff > framedelay) {
				delta = diff/1000f;
				onUpdate();
				
				g2d.setColor(clearcolor);
				g2d.fillRect(0, 0, WIDTH, HEIGHT);
				onRender();
				repaint();

				lasttime = System.currentTimeMillis();
			} else {
				long sleeptime = (long) (framedelay - diff - 1);
				try {
					Thread.sleep(sleeptime);
				} catch (Exception ex) {
					System.out.println("Too much coffee today!");
				}
			}
		}
		*/
	}
	public void start() {
		canvas = new BufferedImage(WIDTH, HEIGHT, BufferedImage.TYPE_4BYTE_ABGR);
		g2d = (Graphics2D)canvas.getGraphics();
		
		JFrame hateframe = new JFrame();
			hateframe.pack();
			insl = hateframe.getInsets().left;
			insr = hateframe.getInsets().right;
			inst = hateframe.getInsets().top;
			insb = hateframe.getInsets().bottom;
		hateframe = null;
		
		setTitle(".");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(WIDTH+insl+insr, HEIGHT+inst+insb);
		setVisible(true);
		
		addMouseMotionListener(this);
		
		initialized = true;
		lasttime = System.currentTimeMillis();
		new Thread(this).start();
	}
	
	// event spam
	public synchronized final void mouseClicked(MouseEvent ev) {
		for (MouseL l : mouselisteners) {
			l.mouseClicked(ev.getX()-insl, ev.getY()-inst);
		}
	}	
	public synchronized final void keyTyped(KeyEvent ev) {
		if (!initialized) return;
		for (KeyL l : keylisteners) {
			l.keyTyped(ev.getKeyChar());
		}
	}
	public synchronized final void keyPressed(KeyEvent ev) {
		if (!initialized) return;
		for (KeyL l : keylisteners) {
			l.keyPressed(ev.getKeyCode());
		}
	}
	public synchronized final void mouseDragged(MouseEvent ev) {
		if (!initialized) return;
		for (MouseMotionL l : mousemotionlisteners) {
			l.mouseDragged(ev.getX()-insl, ev.getY()-inst);
		}
	}
	public synchronized final void mouseMoved(MouseEvent ev) {
		if (!initialized) return;
		for (MouseMotionL l : mousemotionlisteners) {
			l.mouseMoved(ev.getX()-insl, ev.getY()-inst);
		}
	}
	public synchronized final void keyReleased(KeyEvent ev) { }
	public synchronized final void mouseEntered(MouseEvent ev) { }
	public synchronized final void mouseExited(MouseEvent ev) { }
	public synchronized final void mousePressed(MouseEvent ev) {
		if (!initialized) return;
		for (MouseMotionL l : mousemotionlisteners) {
			l.mouseDown(ev.getX()-insl, ev.getY()-inst);
		}
	}
	public synchronized final void mouseReleased(MouseEvent ev) {
		if (!initialized) return;
		for (MouseMotionL l : mousemotionlisteners) {
			l.mouseUp(ev.getX()-insl, ev.getY()-inst);
		}
	}

	// font spam
	private final static byte[][] FAIL=
	{{1,1,1,1,1},
	 {1,0,0,0,1},
	 {1,1,0,1,1},
	 {1,0,0,0,1},
	 {1,1,0,1,1},
	 {1,0,0,0,1},
	 {1,1,1,1,1}
	 };
	private final static byte[][] A =
	{{0,0,1,0,0},
	 {0,1,0,1,0},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,1,1,1,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1}
	 };
	private final static byte[][] B =
	{{1,1,1,1,0},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,1,1,1,0},
	 {1,0,0,0,1},
	 {1,1,1,1,0}
	 };
	private final static byte[][] C =
	{{0,0,1,1,0},
	 {0,1,0,0,1},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {0,1,0,0,1},
	 {0,0,1,1,0}
	 };
	private final static byte[][] D =
	{{1,1,1,1,0},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,1,1,1,0}
	 };
	private final static byte[][] E =
	{{1,1,1,1,1},
	 {1,0,0,0,0},
	 {1,1,1,1,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,1,1,1,1}
	 };
	private final static byte[][] F =
	{{1,1,1,1,1},                   
	 {1,0,0,0,0},                   
	 {1,1,1,1,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0}                    
	 };                             
	private final static byte[][] G =
	{{0,1,1,1,0},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,1,1,0},                   
	 {1,0,0,0,1},                   
	 {0,1,1,1,0}                    
	 };                             
	private final static byte[][] H =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,1,1,1,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1}                    
	 };                             
	private final static byte[][] I =
	{{0,1,1,1,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,1,1,1,0}                    
	 };                             
	private final static byte[][] J =
	{{0,0,0,0,1},                   
	 {0,0,0,0,1},                   
	 {0,0,0,0,1},                   
	 {0,0,0,0,1},                   
	 {0,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {0,1,1,1,0}                    
	 };                             
	private final static byte[][] K =
	{{1,0,0,0,1},                   
	 {1,0,0,1,0},                   
	 {1,0,1,0,0},                   
	 {1,1,0,0,0},                   
	 {1,0,1,0,0},                   
	 {1,0,0,1,0},                   
	 {1,0,0,1,0}                    
	 };                             
	private final static byte[][] L =
	{{1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,1,1,1,1}                    
	 };                             
	private final static byte[][] M =
	{{1,0,0,0,1},                   
	 {1,1,0,1,1},                   
	 {1,0,1,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1}                    
	 };                             
	private final static byte[][] N =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,1,0,0,1},                   
	 {1,0,1,0,1},                   
	 {1,0,0,1,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1}                    
	 };                             
	private final static byte[][] O =
	{{0,1,1,1,0},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {0,1,1,1,0}                    
	 };                             
	private final static byte[][] P =
	{{1,1,1,1,0},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,1,1,1,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0}                    
	 };                             
	private final static byte[][] Q =
	{{0,1,1,1,0},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,1,0},                   
	 {0,1,1,0,1}                    
	 };                             
	private final static byte[][] R =
	{{1,1,1,1,0},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,1,1,1,0},                   
	 {1,0,1,0,0},                   
	 {1,0,0,1,0},                   
	 {1,0,0,1,0}                    
	 };                             
	private final static byte[][] S =
	{{0,1,1,1,1},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {1,0,0,0,0},                   
	 {0,1,1,1,0},                   
	 {0,0,0,0,1},                   
	 {1,1,1,1,0}                    
	 };                             
	private final static byte[][] T =
	{{1,1,1,1,1},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0}                    
	 };                             
	private final static byte[][] U =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {0,1,1,1,0}                    
	 };                             
	private final static byte[][] V =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {0,1,0,1,0},                   
	 {0,0,1,0,0}                    
	 };                             
	private final static byte[][] W =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,1,0,1},                   
	 {0,1,0,1,0}                    
	 };                             
	private final static byte[][] X =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {0,1,0,1,0},                   
	 {0,0,1,0,0},                   
	 {0,1,0,1,0},                   
	 {1,0,0,0,1}                    
	 };                             
	private final static byte[][] Y =
	{{1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {1,0,0,0,1},                   
	 {0,1,0,1,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0},                   
	 {0,0,1,0,0}                    
	 };                             
	private final static byte[][] Z =
	{{1,1,1,1,1},
	 {0,0,0,0,1},
	 {0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {1,0,0,0,0},
	 {1,1,1,1,1}
	 };
	private final static byte[][] SPACE =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] EXCL =
	{{0,1,0,0,0},
	 {0,1,0,0,0},
	 {0,1,0,0,0},
	 {0,1,0,0,0},
	 {0,1,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0}
	 };
	private final static byte[][] QUEST =
	{{0,0,0,0,0},
	 {0,1,1,0,0},
	 {1,0,1,0,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0}
	 };
	private final static byte[][] COLON =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] NUM0 =
	{{0,1,1,1,0},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,1,0,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {0,1,1,1,0}
	 };
	private final static byte[][] NUM1 =
	{{0,0,0,1,0},
	 {0,0,1,1,0},
	 {0,1,0,1,0},
	 {0,0,0,1,0},
	 {0,0,0,1,0},
	 {0,0,0,1,0},
	 {0,0,0,1,0}
	 };
	private final static byte[][] NUM2 =
	{{0,1,1,1,0},
	 {1,0,0,0,1},
	 {0,0,0,0,1},
	 {0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {1,1,1,1,1}
	 };
	private final static byte[][] NUM3 =
	{{1,1,1,1,1},
	 {0,0,0,0,1},
	 {0,0,0,0,1},
	 {0,0,0,0,1},
	 {0,1,1,1,1},
	 {0,0,0,0,1},
	 {1,1,1,1,0}
	 };
	private final static byte[][] NUM4 =
	{{1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,1,0,0},
	 {1,0,1,0,0},
	 {1,1,1,1,1},
	 {0,0,1,0,0}
	 };
	private final static byte[][] NUM5 =
	{{1,1,1,1,1},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {0,1,1,1,0},
	 {0,0,0,0,1},
	 {1,0,0,0,1},
	 {0,1,1,1,0}
	 };
	private final static byte[][] NUM6 =
	{{0,1,1,1,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,1,1,1,0},
	 {1,0,0,0,1},
	 {0,1,1,1,0}
	 };
	private final static byte[][] NUM7 =
	{{1,1,1,1,1},
	 {1,0,0,0,1},
	 {0,0,0,0,1},
	 {0,0,1,1,1},
	 {0,0,0,0,1},
	 {0,0,0,0,1},
	 {0,0,0,0,1}
	 };
	private final static byte[][] NUM8 =
	{{0,1,1,1,0},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {0,1,1,1,0},
	 {1,0,0,0,1},
	 {0,1,1,1,0}
	 };
	private final static byte[][] NUM9 =
	{{0,1,1,1,0},
	 {1,0,0,0,1},
	 {0,1,1,1,1},
	 {0,0,0,0,1},
	 {0,0,0,0,1},
	 {0,0,0,0,1},
	 {0,0,0,1,0}
	 };
	private final static byte[][] DOT =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,1,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] COMMA =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0},
	 {1,0,0,0,0}
	 };
	private final static byte[][] BRACEIN =
	{{0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,0,1,0}
	 };
	private final static byte[][] BRACEOUT =
	{{0,1,0,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0}
	 };
	private final static byte[][] AT =
	{{0,1,1,1,0},
	 {1,0,0,0,1},
	 {1,0,0,0,1},
	 {1,0,1,0,1},
	 {1,0,1,1,1},
	 {1,0,0,0,0},
	 {0,1,1,1,0}
	 };
	private final static byte[][] MINUS =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,1,1,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] PLUS =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,1,0,0},
	 {0,1,1,1,0},
	 {0,0,1,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] UNDERSCORE =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {1,1,1,1,1}
	 };
	private final static byte[][] SEP =
	{{0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,0,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0}
	 };
	private final static byte[][] DOLLAR =
	{{0,0,1,0,0},                   
	 {0,1,1,1,1},                   
	 {1,0,1,0,0},                   
	 {0,1,1,1,0},                   
	 {0,0,1,0,1},                   
	 {1,1,1,1,0},                   
	 {0,0,1,0,0}                    
	 };
	private final static byte[][] HASH =
	{{0,0,0,0,0},                   
	 {0,1,0,1,0},                   
	 {0,1,0,1,0},                   
	 {1,1,1,1,1},                   
	 {0,1,0,1,0},                   
	 {1,1,1,1,1},                   
	 {0,1,0,1,0}                    
	 };
	private final static byte[][] SEMICOLON =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,0},
	 {1,0,0,0,0}
	 };
	private final static byte[][] TRIIN = // <
	{{0,0,0,0,0},
	 {0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {0,0,1,0,0},
	 {0,0,0,1,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] TRIOUT = // >
	{{0,0,0,0,0},
	 {0,1,0,0,0},
	 {0,0,1,0,0},
	 {0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] ACCENT = // '
	{{0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] SLASH = // /
	{{0,0,0,0,0},
	 {0,0,0,0,1},
	 {0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {1,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] BACKSLASH = // \
	{{0,0,0,0,0},
	 {1,0,0,0,0},
	 {0,1,0,0,0},
	 {0,0,1,0,0},
	 {0,0,0,1,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] PERCENT = // %
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,1,0,0,1},
	 {0,0,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,0,0},
	 {1,0,0,1,0}
	 };
	private final static byte[][] STRING = // "
	{{0,1,0,1,0},
	 {0,1,0,1,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] POW = // ^
	{{0,0,1,0,0},
	 {0,1,0,1,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] STAR = // *
	{{0,1,0,1,0},
	 {0,0,1,0,0},
	 {0,1,0,1,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] EQU =
	{{0,0,0,0,0},
	 {0,0,0,0,0},
	 {0,0,0,0,0},
	 {1,1,1,1,0},
	 {0,0,0,0,0},
	 {1,1,1,1,0},
	 {0,0,0,0,0}
	 };
	private final static byte[][] SQBRIN = // square brace in [
	{{0,0,1,1,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,1,0}
	 };
	private final static byte[][] SQBROUT = // ]
	{{0,1,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,1,1,0,0}
	 };
	private final static byte[][] WABRIN = // {
	{{0,0,1,1,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,1,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,1,0}
	 };
	private final static byte[][] WABROUT = // }
	{{0,1,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,0,1,1,0},
	 {0,0,1,0,0},
	 {0,0,1,0,0},
	 {0,1,1,0,0}
	 };
	
	public final static byte[][] HAPPY =
	{{0,0,0,0,0},
	 {0,1,0,1,0},
	 {0,1,0,1,0},
	 {0,0,0,0,0},
	 {1,0,0,0,1},
	 {0,1,1,1,0},
	 {0,0,0,0,0}
	 };
	public final static byte[][] UNHAPPY =
	{{0,0,0,0,0},
	 {0,1,0,1,0},
	 {0,1,0,1,0},
	 {0,0,0,0,0},
	 {0,1,1,1,0},
	 {1,0,0,0,1},
	 {0,0,0,0,0}
	 };
	public final static byte[][] DVER =
	{{1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0},
	 {1,0,0,0,0}
	 };
	
	public static byte[][] charToMap(char x) {
		switch(x) {
		case 'a':
		case 'A': return A;
		case 'b':
		case 'B': return B;
		case 'c':
		case 'C': return C;
		case 'd':
		case 'D': return D;
		case 'e':
		case 'E': return E;
		case 'f':
		case 'F': return F;
		case 'g':
		case 'G': return G;
		case 'h':
		case 'H': return H;
		case 'i':
		case 'I': return I;
		case 'j':
		case 'J': return J;
		case 'k':
		case 'K': return K;
		case 'l':
		case 'L': return L;
		case 'm':
		case 'M': return M;
		case 'n':
		case 'N': return N;
		case 'o':
		case 'O': return O;
		case 'p':
		case 'P': return P;
		case 'q':
		case 'Q': return Q;
		case 'r':
		case 'R': return R;
		case 's':
		case 'S': return S;
		case 't':
		case 'T': return T;
		case 'u':
		case 'U': return U;
		case 'v':
		case 'V': return V;
		case 'w':
		case 'W': return W;
		case 'x':
		case 'X': return X;
		case 'y':
		case 'Y': return Y;
		case 'z':
		case 'Z': return Z;
		case '0': return NUM0;
		case '1': return NUM1;
		case '2': return NUM2;
		case '3': return NUM3;
		case '4': return NUM4;
		case '5': return NUM5;
		case '6': return NUM6;
		case '7': return NUM7;
		case '8': return NUM8;
		case '9': return NUM9;
		
		case '.': return DOT;
		case '!': return EXCL;
		case '?': return QUEST;
		case ' ': return SPACE;
		case ':': return COLON;
		case ';': return SEMICOLON;
		case ',': return COMMA;
		case '@': return AT;
		case '-': return MINUS;
		case '+': return PLUS;
		case '_': return UNDERSCORE;
		case '|': return SEP;
		case '$': return DOLLAR;
		case '#': return HASH;
		case'\'': return ACCENT;
		case '/': return SLASH;
		case'\\': return BACKSLASH;
		case '%': return PERCENT;
		case '"': return STRING;
		case '^': return POW;
		case '*': return STAR;
		case '=': return EQU;
		
		case '(': return BRACEIN;
		case ')': return BRACEOUT;
		case '<': return TRIIN;
		case '>': return TRIOUT;
		case '[': return SQBRIN;
		case ']': return SQBROUT;
		case '{': return WABRIN;
		case '}': return WABROUT;
		
		// my own special chars
		case 128: return HAPPY;
		case 129: return UNHAPPY;
		case 130: return DVER;
		}
		return FAIL;
	}
	
	public int drawChar(int x, int y, byte[][] map, Color cl) { return drawChar(x, y, map, cl, 2); }
	public int drawChar(int x, int y, byte[][] map, Color cl, int s) {
		
		for (int my=0; my<map.length; my++) {
			for (int mx=0; mx<map[0].length; mx++) {
				if (map[my][mx] == 1) {
					for (int cx=0; cx<s; cx++) {
						for (int cy=0; cy<s; cy++) {
							set(cx+mx*s+x, cy+my*s+y, cl);
						}
					}
					
					/*
					set(x+mx*s  , y+my*s  , cl);
					set(x+mx*s  , y+my*s+1, cl);
					set(x+mx*s+1, y+my*s  , cl);
					set(x+mx*s+1, y+my*s+1, cl);
					*/
				}
			}
		}
		return map[0].length * s;
	}
	public int drawChar(int x, int y, char chr    , Color cl, int s) {
		return drawChar(x,y,charToMap(chr), cl, s);
	}
	public static int gsdrawChar(int x, int y, byte[][] map, Color cl, int s, GSnip onwhat) {
		for (int my=0; my<map.length; my++) {        // vv
			for (int mx=0; mx<map[0].length; mx++) { // iterate thought all chars
				
				
				if (map[my][mx] == 1) {
					for (int cx=0; cx<s; cx++) {
						for (int cy=0; cy<s; cy++) {
							onwhat.set(cx+mx*s+x, cy+my*s+y, cl);
							
							//onwhat.set(mx+x+cx, my+y+cy, cl);
						}
					}
				}
				
				
			}
		}
		return map[0].length * s;
	}
	public static int gsdrawChar(int x, int y, char chr, Color cl, int s, GSnip onwhat) {
		return gsdrawChar(x,y,charToMap(chr), cl, s, onwhat);
	}
	
	public static int textlen(String text, int scale) {
		return text.length()*(5*(scale+2));
	}
	
	public void text(int x, int y, String text) {
		text(x,y,text,2);
	}
	public void text(int x, int y, String text, int scale) {
		text(x, y, text, Color.LIGHT_GRAY, scale);
	}
	public void text(int x, int y, String text, Color cl) {
		text(x, y, text, cl, 2);
	}
	public void text(int x, int y, String text, Color cl, int scale) {
		int xoff = 0;
		for (int i=0; i<text.length(); i++) {
			xoff +=scale+ drawChar(x+xoff,y, charToMap(text.charAt(i)), cl, scale);
		}
	}
	
	public static int gstext(int x, int y, String text, Color cl, int scale, GSnip onwhat) {
		int xoff = 0;
		for (int i=0; i<text.length(); i++) {
			xoff +=scale+ gsdrawChar(x+xoff,y, charToMap(text.charAt(i)), cl, scale, onwhat);
		}
		return xoff;
	}

}





package view;

import java.awt.Color;

/**GSnip. Simple snippet of pixels for rendering.
 * Acts a bit like an image. Other components render to this one
 * and then the view.View renders them on the real canvas.
 * 
 * Supports transparency! if a cell is NULL: transparent!
 * 
 * @author lk
 */
public class GSnip {
	public Color[][] map;
	
	public GSnip(int xsize, int ysize) {
		map = new Color[xsize][ysize];
	}
	public GSnip(Color[][] colors) {
		this.map = colors;
	}
	
	public int xlen() { return map.length; }
	public int ylen() { return map[0].length; }
	
	
	
	public void drawonto(GSnip onto, int x, int y) {
		for (int mx=0; mx<xlen(); mx++) {
			for (int my=0; my<ylen(); my++) {
				onto.set(x+mx, y+my, GraphicsEngine.blenda(onto.get(x+mx, y+my), this.get(mx,my)));
			}
		}
	}
	public void drawonto(GSnip onto, int x,int y,  int maxx,int maxy) {
		for (int mx=0; mx<maxx; mx++) {
			for (int my=0; my<maxy; my++) {
				onto.set(x+mx, y+my, GraphicsEngine.blenda(onto.get(x+mx, y+my), this.get(mx,my)));
			}
		}
	}
	
	public void drawfrom(GSnip source, int x,int y) {
		for (int mx=0; mx<source.xlen(); mx++) {
			for (int my=0; my<source.ylen(); my++) {
				this.set(mx+x, my+y, GraphicsEngine.blenda(this.get(x+mx, my+y),source.get(mx, my)));
			}
		}
	}
	public void drawfrom(GSnip source, int x,int y,  int maxx,int maxy) {
		for (int mx=0; mx<maxx; mx++) {
			for (int my=0; my<maxy; my++) {
				this.set(x+mx, my+y, GraphicsEngine.blenda(this.get(mx+x, my+y), source.get(mx, my)));
			}
		}
	}
	
	public void render(GraphicsEngine ge, int x,int y) {
		for (int mx=0; mx<xlen(); mx++) {
			for (int my=0; my<ylen(); my++) {
				ge.set(mx+x, my+y, GraphicsEngine.blend(ge.get(mx+x, my+y), get(mx,my)));
			}
		}
	}
	public void render(GraphicsEngine ge, int x,int y,  int maxx,int maxy) {
		for (int mx=0; mx<maxx; mx++) {
			for (int my=0; my<maxy; my++) {
				ge.set(mx+x, my+y, GraphicsEngine.blend(ge.get(mx+x, my+y), get(mx,my)));
			}
		}
	}
	
	
	
	public void set(int x, int y, Color c) {
		if (x<0 || y<0 || x>=map.length || y>=map[0].length) return;
		if (map[x][y] == null) { map[x][y] = c; return; }
		
		map[x][y] = GraphicsEngine.blenda(map[x][y], c);
	}
	public void setraw(int x, int y, Color c) {
		if (x<0 || y<0 || x>=map.length || y>=map[0].length) return;
		
		map[x][y] = c;
	}
	public Color get(int x, int y) {
		if (x<0 || y<0 || x>=map.length || y>=map[0].length) return null;
		return map[x][y];
	}
}






package view.gui;

public class Box {
	public int tx,ty, xs,ys;
	public Object reference;
	
	public Box() { }
	public Box(int x, int y, int xs, int ys) {
		this.tx=x;
		this.ty=y;
		this.xs=xs;
		this.ys=ys;
	}
	
	public boolean inside(int x, int y) {
		if (tx<x || ty<y || ty>=y || tx>=x) return false;
		return true;
	}
	public boolean outside(int x, int y) {
		if (tx<x || ty<y || ty>=y || tx>=x) return true;
		return false;
	}
}
package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class Button extends Component {
	
	protected String text;
	
	public Button() {
		super();
		text = "Button";
		initSize(80, 15);
		initPosition(0,0);
	}
	
	@Override
	public GSnip redraw() {
		GSnip gs = new GSnip(xs,ys);
		
		for (int x=0; x<xs; x++) {
			for (int y=0; y<ys; y++) {
				gs.setraw(x, y, new Color(100, 200, 100, 200));
			}
		}
		
		GraphicsEngine.gstext(4, 4, text, Color.GREEN, 1, gs);
		
		return gs;
	}
	
	protected void oClick() {
		text = "ouch!";
	}
	
	public boolean eventMouseClick(int x, int y) {
		oClick();
		return true;
	}

	public void setText(String text) {
		this.text = text;
	}
}
package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class CheckBox extends Component {
	
	boolean state;
	String text;
	int step; // 0,1,2,3,4,5,6,7 (8 elements)
	// 012
	// 7 3
	// 654
	
	public CheckBox() {
		state = false;
		step = 0;
		
		ys =  7;
		xs = 80;
	}
	
	public int setText(String text) {
		this.text = text;
		return GraphicsEngine.textlen(text, 1) + 10;
	}
	
	public GSnip redraw() {
		step++;
		if (step>7) step=0;
		
		if(xs<1)xs=1; if(ys<1)ys=1;
		GSnip gs = new GSnip(xs, ys);
		
		for (int x=0; x<7; x++) {
			for (int y=0; y<7; y++) {
				gs.setraw(x,y, new Color(40, 170, 70, (int)(Math.random()*70+150)));
			}
		}
		for (int x=1; x<6; x++) {
			for (int y=1; y<6; y++) {
				gs.setraw(x,y, new Color(40, 100, 50, 150));
			}
		}
		
		if (state) {
			int prevstep = step;
			for (int i=0; i<4; i++) {
				step++;
				if (step>7) step = 0;
				switch(step) {
				case 0: gs.set(2+0, 2+0, Color.green); break;
				case 1: gs.set(2+1, 2+0, Color.green); break;
				case 2: gs.set(2+2, 2+0, Color.green); break;
				case 3: gs.set(2+2, 2+1, Color.green); break;
				case 4: gs.set(2+2, 2+2, Color.green); break;
				case 5: gs.set(2+1, 2+2, Color.green); break;
				case 6: gs.set(2+0, 2+2, Color.green); break;
				case 7: gs.set(2+0, 2+1, Color.green); break;
				default: gs.set(3,3, Color.red); break;
				}
			}
			step = prevstep;
		}
		
		GraphicsEngine.gstext(10, 0, text,new Color(40, 255, 40, 230), 1, gs);
		
		return gs;
	}
	
	/**Empty. Overridable. Go wild. */
	protected void oStateChange() { }
	
 	public boolean eventMouseClick(int x, int y) {
		state = !state; // invert/toggle
		oStateChange();
		return true;
	}
	
}
package view.gui;

import view.GSnip;

/**init* resize move redraw*/
public class Component implements WindowManager.KeyL, WindowManager.MouseL, WindowManager.MouseMotionL {
	int x,y, xs,ys; // coords and size (on the parent container)
	Container myparent; // direct parent (the container) (if null: this is mywindow's 'the')
	Window mywindow; // the window we are inside.
	
	public void initW(Window window) { this.mywindow = window; }
	public void initParent(Container myparent) { this.myparent = myparent; }
	public void initSize(int xs, int ys) { this.xs=xs; this.ys=ys; }
	public void initPosition(int x, int y) { this.x=x; this.y=y; }
	public Component() {
		x =0; y =0;
		xs=1; ys=1;
	}
	
	/**Do not use yet*/
	public void poke() { } // request for redraw. (useful for containers only)
	
	public void resize(int xs, int ys) { this.xs=xs; this.ys=ys; }
	public void move(int x, int y) { this.x=x; this.y=y;}

	public GSnip redraw() {
		return null;
	}

	public boolean eventMouseClick(int x, int y) { return false; }
	public boolean eventMouseMove(int x, int y) { return false; }
	public boolean eventMouseDrag(int x, int y) { return false; }
	public boolean eventKeyCode(int code) { return false; }
	public boolean eventKeyChar(char chr) { return false; }
}
package view.gui;

import java.awt.Color;
import java.util.List;
import java.util.LinkedList;

import view.GSnip;
import view.GraphicsEngine;

/**This poor thing also has to take over parental forces*/
public class Container extends Component {
	private List<Component> list;
	Component focus;
	
	public Container() {
		list = new LinkedList<Component>();
		focus = null;
	}
	
	public GSnip redraw() {
		GSnip gs = new GSnip(xs, ys);
		
		// TV effect
		final int s = 2; // scale
		for (int x=0; x<gs.xlen()/s+s; x++) {
			for (int y=0; y<gs.ylen()/s+s; y++) {
				//gs.set(x, y, new Color((int)(Math.random()*20f), (int)(Math.random()*50f), (int)(Math.random()*70f)));
				Color c = new Color((int)(Math.random()*7f), (int)(Math.random()*25f), (int)(Math.random()*40f), (int)(Math.random()*20)+230);
				for (int cx=0; cx<s; cx++) {
					for (int cy=0; cy<s; cy++) {
						gs.set(x*s+cx, y*s+cy, c);
					}
				}
			}
		}
		
		// components
		for (Component c : list) {
			c.redraw().drawonto(gs, c.x, c.y);
		}
		
		return gs;
	}
	
	public Component getCompAt(int x, int y) {
		for (Component c : list) {
			if (x>=c.x && x<c.x+c.xs && y>=c.y && y<c.y+c.ys) return c;
		}
		return null;
	}
	
	public Component getFocus() { return focus; }
		
	public void add(Component wut) { list.add(wut); }
	public void remove(Component wut) { list.remove(wut); }
	public void ensure(Component wut) { if (list.contains(wut))return; add(wut); }
	
	public void poke() { for(Component c : list) c.poke(); }
	public void resize(int xs, int ys) { super.resize(xs, ys); }
	public void move(int x, int y) { super.move(x, y); }

	public boolean eventMouseClick(int x, int y) {
		Component found = getCompAt(x,y);
		focus = found;
		if (found == null) { return false;}
		
		found.eventMouseClick(x-found.x, y-found.y);
		return true;
	}
	public boolean eventMouseMove(int x, int y) {
		Component found = getCompAt(x,y);
		if (found == null) { return false;}
		
		found.eventMouseMove(x-found.x, y-found.y);
		return true;
	}
	public boolean eventMouseDrag(int x, int y) {
		Component found = getCompAt(x,y);
		if (found == null) { return false;}
		
		found.eventMouseDrag(x-found.x, y-found.y);
		return true;
	}
	public boolean eventKeyCode(int code) {
		if (focus == null) return false;
		return focus.eventKeyCode(code);
	}
	public boolean eventKeyChar(char chr) {
		if (focus == null) return false;
		return focus.eventKeyChar(chr);
	}


}
















package view.gui;

import java.awt.Color;
import java.awt.event.KeyEvent;

import view.GSnip;
import view.GraphicsEngine;

/**Single line! @see TextBox for fixWord*/
public class EditBox extends Component {
	protected String text;
	
	public EditBox() {
		text = "hai";
		initSize(80, 13);
	}
	
	@Override
	public GSnip redraw() {
		if (xs<=0) xs=1; if (ys<=0)ys=1;
		GSnip gs = new GSnip(xs, ys);
		
		Color fill = new Color(50, 70, 50, 100);
		if (myparent != null && myparent.getFocus() == this) fill = new Color(30, 70, 30, 170);
		
		for (int x=0; x<xs; x++) {
			for (int y=0; y<ys; y++) {
				gs.set(x,y, new Color(50, 90, 50, (int)(Math.random()*100+150)));
			}
		}
		for (int x=1; x<xs-1; x++) {
			for (int y=1; y<ys-1; y++) {
				gs.setraw(x,y, fill);
			}
		}
		
		int len = GraphicsEngine.gstext(2, 3, text, new Color(40, 255, 40, 255), 1, gs);
		
		if (myparent != null && myparent.getFocus() == this) {
			GraphicsEngine.gsdrawChar(2+len, 3, (char)130, new Color(20, 150, 40, 200), 1, gs);
		}
		
		return gs;
	}
	
	public String getText() { return text; }
	public void setText(String text) { this.text = text; }
	
	
	public boolean eventKeyChar(char chr) {
		if (chr == KeyEvent.VK_BACK_SPACE) {
			int len = text.length();
			if (len <= 0) return true;
			text = text.substring(0, len-1);
			return true;
		}
		text+=chr;
		return true;
	}
	
}




package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class FixPaint extends Window {
	
	protected GSnipComponent canvas;
	
	public FixPaint() {
		//initThe(new Container());
		super();
		setCaption("fixPaint");
		
		the.add(canvas = new GSnipComponent(xs, ys));
		canvas.initParent(the);
		canvas.move(0, 0);
		canvas.resize(100, 100);
		canvas.initW(this);
	}
	
	public boolean eventMouseDrag(int x, int y) {
		canvas.set(x-the.x, y-the.y, new Color(200, 30, 30, (int)(Math.random()*50+205)));
		return true;
	}
	
}









package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class GSnipComponent extends Component {

	public Color[][] map;
	
	public GSnipComponent(int xsize, int ysize) {
		map = new Color[xsize][ysize];
	}
	
	public int xlen() { return map.length; }
	public int ylen() { return map[0].length; }
	
	@Override
	public GSnip redraw() {
		return new GSnip(map);
	}
	
	public void drawonto(GSnip onto, int x, int y) {
		for (int mx=0; mx<xlen(); mx++) {
			for (int my=0; my<ylen(); my++) {
				onto.set(x+mx, y+my, GraphicsEngine.blenda(onto.get(x+mx, x+my), this.get(mx,my)));
			}
		}
	}
	public void drawonto(GSnip onto, int x,int y,  int maxx,int maxy) {
		for (int mx=0; mx<maxx; mx++) {
			for (int my=0; my<maxy; my++) {
				onto.set(x+mx, y+my, GraphicsEngine.blenda(onto.get(x+mx, x+my), this.get(mx,my)));
			}
		}
	}
	
	public void drawfrom(GSnip source, int x,int y) {
		for (int mx=0; mx<source.xlen(); mx++) {
			for (int my=0; my<source.ylen(); my++) {
				this.set(mx+x, my+y, GraphicsEngine.blenda(this.get(x+mx, my+y),source.get(mx, my)));
			}
		}
	}
	public void drawfrom(GSnip source, int x,int y,  int maxx,int maxy) {
		for (int mx=0; mx<maxx; mx++) {
			for (int my=0; my<maxy; my++) {
				this.set(x+mx, my+y, GraphicsEngine.blenda(this.get(mx+x, my+y), source.get(mx, my)));
			}
		}
	}
	
	public void render(GraphicsEngine ge, int x,int y) {
		for (int mx=0; mx<xlen(); mx++) {
			for (int my=0; my<ylen(); my++) {
				ge.set(mx+x, my+y, GraphicsEngine.blend(ge.get(mx+x, my+y), get(mx,my)));
			}
		}
	}
	public void render(GraphicsEngine ge, int x,int y,  int maxx,int maxy) {
		for (int mx=0; mx<maxx; mx++) {
			for (int my=0; my<maxy; my++) {
				ge.set(mx+x, my+y, GraphicsEngine.blend(ge.get(mx+x, my+y), get(mx,my)));
			}
		}
	}
	
	
	
	public void set(int x, int y, Color c) {
		if (x<0 || y<0 || x>=map.length || y>=map[0].length) return;
		if (map[x][y] == null) { map[x][y] = c; return; }
		
		map[x][y] = GraphicsEngine.blenda(map[x][y], c);
	}
	public void setraw(int x, int y, Color c) {
		if (x<0 || y<0 || x>=map.length || y>=map[0].length) return;
		
		map[x][y] = c;
	}
	public Color get(int x, int y) {
		if (x<0 || y<0 || x>=map.length || y>=map[0].length) return null;
		return map[x][y];
	}
}
package view.gui;

import java.awt.Color;

import view.GSnip;

public class HealthBar extends Component {
	float howmuch; // 0f-1f
	int step; // 0-4
	
	public HealthBar() {
		super();
		step = 0;
		howmuch = 1f;
		
		ys = 8;
		xs = 150;
	}
	
	public void setProgress(float howmuch) { if (howmuch <0f || howmuch>1f) return; this.howmuch = howmuch; }
	
	// horizontal always
	public GSnip redraw() {
		GSnip gs = new GSnip(xs,ys);
		step++;
		//if (step>5) step=0;
		
		for (int x=0; x<xs; x++) {
			for (int y=0; y<ys; y++) {
				gs.set(x, y, new Color(90, 90, 15, (int)(Math.random()*80+150)));
			}
		}
		
		Color cempty = new Color(70, 35, 70, 80);
		Color c0 = new Color(250, 100,  50, 255); // false
		Color c1 = new Color(200,  70, 100, 250); // true
		
		Color use;
		boolean c = false; 
		
		for (int x=1; x<xs-1; x++) {
			use = cempty;
			c = false;
			for (int y=1; y<ys-1; y++) {
				use = c1;
				if ((x+step+y)%100 == 0) use = c0;
				
				if ((float)x/(float)xs > howmuch) {
					use = cempty;
				}
				gs.setraw(x, y, use);
			}
		}

		return gs;
	}
}
package view.gui;

import view.GSnip;
import model.Inventory;
import model.InventorySlot;

// spr == slots per row

public class InventoryDisplay extends Component {
	private final Inventory inv;
	
	public InventoryDisplay(Inventory inv, int spr) {
		super();
		this.inv = inv;
	}
	
	@Override
	public GSnip redraw() {
		if (xs<=0)xs=1; if(ys<=0)ys=1;
		GSnip gs = new GSnip(xs,ys);
		
		
		
		return gs;
	}
}
package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class Label extends Component {
	
	protected String text;
	
	public Label() {
		text = "Label";
	}
	
	public GSnip redraw() {
		ys=7;
		xs=GraphicsEngine.textlen(text, 1);
		
		GSnip gs = new GSnip(xs, ys);
		GraphicsEngine.gstext(0, 0, text, Color.cyan.darker(), 1, gs);
		
		return gs;
	}

	public void setText(String text) { this.text = text; }
	public String getText() { return text; }
}
package view.gui;

import model.Model;

public class MainMenu extends Window {
	
	Model model;
	
	Button millis;
	Button addpaint;
	Label millisdisplay;
	EditBox randomtext;
	CheckBox pause;
	HealthBar progress;
	Button savegame;
	EditBox savename;
	
	public void initsModel(Model m) { this.model = m; }
	public MainMenu() {
		super();
		setCaption(""+(char)128+" Mainmenu");
		
		resize(200, 150);
		
		// label to display miliseconds (-> )
		the.add(millisdisplay = new Label());
		millisdisplay.initParent(the);
		millisdisplay.initW(this);
		millisdisplay.initPosition(10, 30);
		millisdisplay.setText("System.currentTimeMillis();");
		
		// miliseconds trigger
		the.add(millis=new Button(){ protected void oClick() {
			millisdisplay.setText(""+System.currentTimeMillis());
		}});
		millis.initParent(the);
		millis.initW(this);
		millis.initPosition(10, 8);
		millis.setText("millis");
		
		the.add(addpaint=new Button(){ protected void oClick() {
			if (mywm != null) {
				FixPaint fp = new FixPaint();
				fp.initWM(mywm);
				fp.resize(100, 100);
				fp.move(10, 10);
				mywm.add(fp);
			}
		}});
		addpaint.initParent(the);
		addpaint.initW(this);
		addpaint.initPosition(95, 8);
		addpaint.setText("fixPaint");
		
		/*the.add(randomtext = new EditBox());
		randomtext.initParent(the);
		randomtext.initW(this);
		randomtext.initPosition(14, 43);
		randomtext.initSize(the.xs-15-15, randomtext.ys);*/
		
		the.add(pause = new CheckBox(){protected void oStateChange() {
			if (model == null) return;
			model.pause(state);
		}});
		pause.initParent(the);
		pause.initW(this);
		pause.initPosition(9, 60);
		pause.initSize(pause.setText("Pause updating?"), pause.ys);
		
		the.add(progress = new HealthBar());
		progress.initW(this);
		progress.initParent(the);
		progress.initSize(100, progress.ys);
		progress.setProgress(0.7f);
		progress.initPosition(14, 70);
		
		the.add(savegame = new Button(){ protected void oClick() {
			text = "Saving...";
			if (model == null) { text = "Save [ERR]"; return; }
			model.save(savename.getText());
			text = "Save";
		}});
		savegame.initW(this);
		savegame.initParent(the);
		savegame.initPosition(10, 100);
		savegame.setText("Save");
		
		the.add(savename = new EditBox());
		savename.initW(this);
		savename.initParent(the);
		savename.initSize(xs-10-10, savename.ys);
		savename.initPosition(10, 83);
		savename.setText("My save 1");
		
	}
}









package view.gui;

import java.awt.Color;

import view.GSnip;

public class ProgressBar extends Component {
	float howmuch; // 0f-1f
	int step; // 0-4
	
	public ProgressBar() {
		super();
		step = 0;
		howmuch = 0f;
		
		ys = 8;
		xs = 150;
	}
	
	public void setProgress(float howmuch) { if (howmuch <0 || howmuch>1) return; this.howmuch = howmuch; }
	
	// horizontal always
	public GSnip redraw() {
		GSnip gs = new GSnip(xs,ys);
		step++;
		//if (step>5) step=0;
		
		for (int x=0; x<xs; x++) {
			for (int y=0; y<ys; y++) {
				gs.set(x, y, new Color(30, 150, 15, (int)(Math.random()*80+150)));
			}
		}
		
		Color cempty = new Color(50, 70, 50, 80);
		Color c0 = new Color(100, 200,  50, 255); // false
		Color c1 = new Color( 50, 200, 100, 250); // true
		
		Color use;
		boolean c = false; 
		
		for (int x=1; x<xs-1; x++) {
			use = cempty;
			c = false;
			for (int y=1; y<ys-1; y++) {
				use = c1;
				if ((x+step+y)%5 == 0) use = c0;
				
				if ((float)x/(float)xs > howmuch) {
					use = cempty;
				}
				gs.setraw(x, y, use);
			}
		}

		return gs;
	}
}













package view.gui;

public class StatsWindow extends Window {
	HealthBar hp;
	Label level;
	ProgressBar exp;
	
	public StatsWindow() {
		super();
		the.add(level = new Label());
		
		/* 110628: healthbar added
		the.add(hp = new HealthBar());
		hp.initParent(the);
		hp.initW(this);
		hp.initPosition(20, 10);
		hp.initSize(the.xs-20-20, hp.ys);
		hp.setProgress(0.2f); */
	}
}
package view.gui;

import java.awt.Color;

import view.*;
import view.gui.WindowManager.WindowState;

public class Window implements WindowManager.KeyL, WindowManager.MouseL, WindowManager.MouseMotionL {
	// const
	public static final int frameleft   = 1;
	public static final int frameright  = 1;
	public static final int framebottom = 1;
	public static final int frametop    = 11;
	
	// type
	// ---
	
	// var
	int x,y, xs,ys; // coords of window, and of WINDOw size. not of the canvas size(see (var)"the")
	String caption;
	Container the; // sub: the main Component handling the canvas (which should behave as container!)
	WindowManager mywm; // parent: my window manager.
	WindowManager.WindowState state;
	
	// init
	public void initWM(WindowManager wm) { this.mywm = wm; }
	public Window() {
		this.state = WindowManager.WindowState.Normal;
		
		caption = "<untitled window>";
		
		x  =  10; y  =  10;
		xs = 100; ys = 100;
		
		the = new Container();
		the.initW(this);
		the.move(frameleft, frametop);
		the.resize(xs-frameleft-frameright, ys-frametop-framebottom);
		
		/*
		initThe(new Container());
		the.initParent(null);
		the.initPosition(frameleft, frametop);
		the.initW(this);
		the.initSize(getUsableCanvasSizeX(), getUsableCanvasSizeY());
		
		initWM(null);
		initSize(100, 100);
		initPosition(0, 0);
		initCaption("(untitled window)");
		initState(WindowState.Normal);
		*/
		
	}
	
	// get
	public int getUsableCanvasSizeX() { return xs-frameleft-frameright; }
	public int getUsableCanvasSizeY() { return ys-frametop-framebottom; }
	public int getX() { return x; }
	public int getY() { return y; }
	public int getWindowSizeX() { return xs; }
	public int getWindowSizeY() { return ys; }
	public Container getThe() { return the; }
	
	// set
	public void setCaption(String caption) { this.caption = caption; }
	
	//? core paint parts
	// ---
	/**Render "the" here. or customize*/
	protected void rReal(GraphicsEngine ge) {
		GSnip gs = the.redraw();
		gs.render(ge, x+the.x, y+the.y, getUsableCanvasSizeX(), getUsableCanvasSizeY());
	}
	
	// core
	public void render(GraphicsEngine ge) {
		float light = 0.77f;
		if (mywm != null && mywm.getFocus() == this) light = 0.95f;
		
		if (state == WindowState.Hold) {
			
			for (int x=this.x; x<this.x+xs; x++) {
				for (int y=this.y; y<this.y+frametop; y++) {
					ge.set(x,y, GraphicsEngine.blendLight(ge.get(x, y), light));
				}
			}
			if (caption != null) {
				GSnip gstitle = new GSnip(xs, frametop);
				GraphicsEngine.gstext(3, 2, caption, Color.cyan.darker(), 1, gstitle);
				
				gstitle.render(ge, this.x, this.y, this.xs+frameleft+frameright+10, frametop);
				
				/*
				for (int x=0; x<gstitle.xlen(); x++) {
					for (int y=0; y<gstitle.ylen(); y++) {
						if ((buf = gstitle.get(x, y)) == null) continue;
						ge.set(this.x+frameleft+x+3, this.y+2+y, gstitle.get(x, y));
					}
				}*/
			}
			// <restore button />
			for (int x=this.x+this.xs-frametop+frameleft; x<this.x+this.xs-1; x++) {
				for (int y=this.y+1; y<this.y+frametop-1; y++) {
					ge.seta(x, y, new Color(120,200,120, 200));
				}
			}
			
			return;
		} // END IF STATE == HOLD
		
		// <FRAME>
		// <titlebar background />
		for (int x=this.x; x<this.x+xs; x++) {
			for (int y=this.y; y<this.y+frametop; y++) {
				if (mywm != null && mywm.getFocus() == this) { ge.set(x,y, GraphicsEngine.blendLight(ge.get(x, y), light)); continue; }
				ge.set(x,y, GraphicsEngine.blendLight(ge.get(x, y), light));
			}
		}
		// left border ( only 1px (dispiting frameleft value))
		for (int y=this.y+frametop; y<this.y+this.ys; y++) {
			ge.set(this.x, y, GraphicsEngine.blendLight(ge.get(x, y), light));
		}
		// right border
		for (int y=this.y+frametop; y<this.y+this.ys; y++) {
			ge.set(this.x+this.xs-frameleft, y, GraphicsEngine.blendLight(ge.get(x+xs, y), light));
		}
		// bottom border
		for (int x=this.x+1; x<this.x+this.xs-1; x++) {
			ge.set(x, this.y+this.ys-framebottom, GraphicsEngine.blendLight(ge.get(x, y+ys), light));
		}
		// <close button />
		for (int x=this.x+this.xs-frametop+frameleft; x<this.x+this.xs-1; x++) {
			for (int y=this.y+1; y<this.y+frametop-1; y++) {
				ge.seta(x, y, new Color(200,150,150, 200));
			}
		}
		
		// <caption />
		if (caption != null) {
			GSnip gstitle = new GSnip(xs, frametop);
			GraphicsEngine.gstext(3, 2, caption, Color.cyan.darker(), 1, gstitle);
			
			gstitle.render(ge, this.x, this.y, this.xs+frameleft+frameright+10, frametop);
			
			/*
			for (int x=0; x<gstitle.xlen(); x++) {
				for (int y=0; y<gstitle.ylen(); y++) {
					if ((buf = gstitle.get(x, y)) == null) continue;
					ge.set(this.x+frameleft+x+3, this.y+2+y, gstitle.get(x, y));
				}
			}*/
		}
		// </FRAME>

		// canvas "the"
		rReal(ge);
		/*
		for (int x=0; x<gs.xlen(); x++) {
			for (int y=0; y<gs.ylen(); y++) {
				//if (y%wr == 0)
				ge.set(this.x+frameleft+x, this.y+frametop+y,
								GraphicsEngine.blend(ge.get(x+this.x+frameleft, y+this.y+frametop), gs.get(x,y)));
			}
		}
		*/
	}
	
	public void poke() {
		if (the != null) the.poke();
	}
	
	int dragx,dragy;
	public boolean startdrag(int x, int y) {
		
		// if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+w.ys) continue;
		if (x<0 || y<0 || x>=this.xs-frameleft-frametop-1 || y>=frametop) return false;
		
		dragx=x;
		dragy=y;
		
		return true;
	}
	public boolean drag(int x, int y) {
		move(this.x-dragx+x, this.y-dragy+y);
		return true;
	}
	public void stopdrag(int x, int y) {
		//move(x,y);
		if (this.x < 0) this.x=0;
		if (this.y < 0) this.y=0;
		if (this.x >= GraphicsEngine.WIDTH-10) this.x = GraphicsEngine.WIDTH-10;
		if (this.y >= GraphicsEngine.HEIGHT-5) this.y = GraphicsEngine.HEIGHT-5;
	}
	
	// ===
	public void resize(int xs, int ys) {
		this.xs=xs;
		this.ys=ys;
		the.resize(xs-frameleft-frameright, ys-frametop-framebottom);
	}
	public void move(int x, int y) { this.x=x; this.y=y; }
	
	public void close() {
		this.state = WindowState.Hold;
		if (mywm != null) mywm.holdAdd(this);
	}
	public void show() { // restore from tray/'hold'
		this.state = WindowState.Normal;
		if (mywm != null) mywm.holdPop(this);
	}
	
	// event
	// TODO
	public boolean eventMouseMove(int x, int y) {
		if (mywm == null) return false;
		if (mywm.isdragging()) return false;
		the.eventMouseMove(x-the.x, y-the.y);
		return true;
	}
	public boolean eventMouseDrag(int x, int y) {
		if (mywm == null) return false;
		if (mywm.isdragging()) return false;
		the.eventMouseDrag(x-the.x, y-the.y);
		return true;
	}
	public boolean eventMouseClick(int x, int y) {
		if (x>=this.xs-frametop+frameleft && y>=1 && x<this.xs-1 && y<frametop-1) {
			if (state == WindowState.Normal) close(); else show(); // toggle
			return true;
		}
		//if (mywm != null) mywm.bringTop(this);
		the.eventMouseClick(x-the.x, y-the.y);
		return true;
	}
	public boolean eventKeyCode(int code) { 
		if (state == WindowState.Hold) return false;
		the.eventKeyCode(code);
		return true;
	}
	public boolean eventKeyChar(char chr) {
		if (state == WindowState.Hold) return false;
		the.eventKeyChar(chr);
		return true;
	}
	
}
















package view.gui;

import view.GraphicsEngine;

public class WindowManager implements GraphicsEngine.KeyL, GraphicsEngine.MouseL, GraphicsEngine.MouseMotionL {
	// const
	// ---
	
	// type
	public enum WindowState { Normal, Hold } // Tray. Maximized. Minimized. etc
	private class Node<T> {
		public T value;
		public Node<T> next, prev;
		public Node(T value) { this.value = value; }
	}
	interface KeyL {
		boolean eventKeyCode(int code);
		boolean eventKeyChar(char chr);
	}
	interface MouseL {
		boolean eventMouseClick(int x, int y);
	}
	interface MouseMotionL {
		boolean eventMouseMove(int x, int y);
		boolean eventMouseDrag(int x, int y);
	}
	
	// var
	private Node<Window> begin, end; // linked list
	private GraphicsEngine ge;
	private Window focus, draglock; // draglock = component which didnt accept builtin drag
	private boolean dragging; // is the focus dragging ? (dragging<->focus DIFFERENT THAN draglock)
	
	// priv
	private Node<Window> getNodeByWindow(Window which) {
		Node<Window> cur = begin;
		while ((cur = cur.next) != null) {
			if (cur.value == which) {
				return cur;
			}
		}
		return null;
	}
	private Window getWindowAt(int x, int y) {
		Node<Window> cur = end; // REVERSED TRAVERSAL. not list (end = topmost)
		do {
			Window w = cur.value;
			if (w == null) continue;
			
			if (w.state == WindowState.Normal && x>=w.x && y>=w.y && x<w.x+w.xs && y<w.y+w.ys           ) return w; // yay!!!!!
			if (w.state == WindowState.Hold   && x>=w.x && y>=w.y && x<w.x+w.xs && y<w.y+Window.frametop) return w; // yay!!!!!
			// more states here...
			
		} while ((cur=cur.prev).prev != null); // cur.prev being "begin". then (begin).prev == null.
		
		return null; // none of them matched
	}
	private void pokeAll() {
		Node<Window> cur = begin;
		while ((cur=cur.next) != null) {
			cur.value.poke();
		}
	}
	
	// init
	public void initGE(GraphicsEngine ge) { this.ge = ge; }
	public WindowManager() {
		dragging = false;
		begin = new Node<Window>(null);
		end = begin;
		
		focus = null;
		ge = null;
	}
	
	// set
	// ---
	
	// get
	public GraphicsEngine getGE() { return this.ge; }
	public Window getFocus() { return focus; } // return focused window
	public boolean isdragging() { return dragging; }
	
	// core
	public void render() {
		Node<Window> cur = begin;
		while ((cur=cur.next) != null) {
			cur.value.render(ge);
		}
	}
	public void rebuild() {
		System.out.println("[view.WindowManager rebuild];"); // TODO
	}

	public void requestredraw() {
		System.out.println("[view.gui.WindowManager requestredraw]!"); // TODO
	}
	
	// ===
	public void add(Window wut) {
		/* from 110624: reversed linkedlist
		Node<Window> node = new Node<Window>(wut);
		node.prev = begin;
		node.next = begin.next;
		begin.next = node;
		if (node.next != null) node.next.prev = node;*/
		
		Node<Window> node = new Node<Window>(wut);
		node.next = null;
		node.prev = end;
		end.next = node;
		end = node;
		if (!dragging) bringTop(wut);

	}
	public void remove(Window wut) {
		Node<Window> node = getNodeByWindow(wut);
		if (node == null) return;
		
		if (node.prev != null) node.prev.next = node.next;
		if (node.next != null) node.next.prev = node.prev;
		node.next = null;
		node.prev = null;
		node.value = null;
	}
	public boolean exists(Window which) {
		Node<Window> cur = begin;
		while ((cur = cur.next) != null) {
			if (cur.value == which) return true;
		}
		return false;
	}
	
	public boolean holdAdd(Window wut) {
		
		return false;
	}
	public boolean holdPop(Window wut) {
		
		return false;
	}
	
	/// "try to gain focus"
	public void bringTop(Window which) {
		Node<Window> result = getNodeByWindow(which);
		if (result == null) return;
		if (result == end) { focus = which; return; }

		/* from 110624: reversed linkedlist
		if (result.prev != null) result.prev.next = result.next;
		if (result.next != null) result.next.prev = result.prev;
		
		result.next = begin.next;
		result.prev = begin;
		begin.next.prev = result;
		begin.next = result;
		
		focus = which;
		*/
		
		/*if (result.prev != null) { result.prev.next = result.next; } // cut
		if (result.next != null) { result.next.prev = result.prev; } // cut
		
		begin.next.prev = result;
		result.prev = begin;
		result.next = begin.next;
		begin.next = result;
		
		focus = which;
		*/
		
		
		end.next = result;
		
		if (result.prev != null) { result.prev.next = result.next; }
		if (result.next != null) { result.next.prev = result.prev; }
		result.next = null;
		result.prev = end;
		end = result;
		focus = end.value;
		
	}
	
	
	// event
	public boolean mouseMoved(int x, int y) {
		if (dragging) return true;
		if (draglock != null) return true;
		
		Window found = getWindowAt(x, y);
		if (found == null) return false;
		found.eventMouseMove(x-found.x, y-found.y);
		return true;
		
		/* 110625
		Node<Window> cur = begin;
		while ((cur=cur.next) != null) {
			Window w = cur.value;
			if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+w.ys) continue;
			w.eventMouseMove(x-w.x, y-w.y);
			return true;
		}
		return false;*/
	}
	public boolean mouseDragged(int x, int y) {
		if (dragging) {
			if (focus == null) { dragging=false; return false; }
			dragging = focus.drag(x-focus.x, y-focus.y); // implies dropping TODO
			return true;
		}
		if (draglock != null) {
			if (x>=draglock.x+Window.frameleft &&
				y>=draglock.y+Window.frametop &&
				x< draglock.x+draglock.xs-Window.frameright &&
				y< draglock.y+draglock.ys-Window.framebottom)
			{
				draglock.eventMouseDrag(x-draglock.x, y-draglock.y);
			}
			
			return true;
		}
		return false;
		
		// should be handled specially via somehting like
		// mouseDown and MouseUp, as you might not want to drag something
		// over every window any give the dragged item to the disposal
		
		/*Node<Window> cur = begin;
		while ((cur=cur.next) != null) {
			Window w = cur.value;
			if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+w.ys) continue;
			bringTop(w);
			w.eventMouseDrag(x-w.x, y-w.y);
			return true;
		}
		return false;
		*/
	}
	public boolean mouseClicked(int x, int y) {
		Window found = getWindowAt(x, y);
		if (found == null) {focus = null; return true;}
		found.eventMouseClick(x-found.x, y-found.y);
		return true;
		
		/* 110625
		Node<Window> cur = begin;
		while ((cur=cur.next) != null) {
			Window w = cur.value;
			if (w==null) continue;
			
			if (w.state==WindowState.Hold && x>=w.x && y>=w.y && x<w.x+w.xs && y<w.y+Window.frametop) { // TODO make coords be in hold area always
				bringTop(w);
				return w.eventMouseClick(x-w.x, y-w.y);
			}
			
			if (w.state==WindowState.Normal && x>=w.x && y>=w.y && x<w.x+w.xs && y<w.y+w.ys) {
				bringTop(w);
				return w.eventMouseClick(x-w.x, y-w.y);
			}
			
			// **
			if (x>=w.x && y>=w.y && x<w.x+w.xs && y<w.y+w.ys); 
			
			if (w.state == WindowState.Hold) if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+Window.frametop) continue; // case Hold
			else                             if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+w.ys           ) continue; // default Normal
			w.eventMouseClick(x-w.x, y-w.y);
			bringTop(w);
			return true;
			** //
		}
		focus = null;
		return false;
		*/
	}
	public boolean keyTyped(char letter) {
		if (focus != null) {
			return focus.eventKeyChar(letter);
			// return true;
		} else return false;
	}
	public boolean keyPressed(int code) {
		if (focus != null) {
			return focus.eventKeyCode(code);
			//return true;
		} else return false;
	}
	public boolean mouseDown(int x, int y) {
		if (dragging) return true;
		if (draglock != null) return true;
		
		Window found = getWindowAt(x,y);
		if (found == null) { focus = null; return false; }
		if (found.startdrag(x-found.x, y-found.y)) {
			dragging = true;
		} else {
			draglock = found;
		}
		bringTop(found);
		return true;
		
		/*
		Node<Window> cur = begin;
		while ((cur=cur.next) != null) {
			Window w = cur.value;
			if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+w.ys) continue;
			if (w.startdrag(x-w.x, y-w.y)) {
				dragging = true;
				bringTop(w);
			} else {
				draglock = w;
			}
			return true;
		}
		return false;
		*/
	}
	public boolean mouseUp(int x, int y) {
		draglock = null;
		if (!dragging) { return false; }
		if (focus == null) { dragging = false; return false; } // window got killed or defocused. reset drag
		
		focus.stopdrag(x-focus.x, y-focus.y);
		dragging = false;
		
		return false;
	}

}















package view;

import java.awt.Color;

import model.BlockX;
import model.Block;
import model.Chunk;
import model.Model;

// useful: wut.getOrig().getColor()

/**x,y are coords on the canvas. thx
 * 
 */
public abstract class RenderBlock {
//	private static final int cs = Chunk.cs;
	private static final int zoom = Model.zoom;
	
	public static void render(Block wut, GraphicsEngine ge, int x, int y) {
		switch (wut) {
		case air: /*renderAir(wut, ge, x, y);*/ break;
		case stone: renderStone(wut, ge, x, y); break;
		case dirt: renderDirt(wut, ge, x, y); break;
		case player: renderPlayer(wut, ge, x, y); break;
		case torch: renderTorch(wut, ge, x, y); break;
		}
	}
	
	private static void renderTorch(Block wut, GraphicsEngine ge, int x, int y)
	{
		simpleFill(ge, Color.yellow.brighter(), x, y);
	}
	
	private static void renderPlayer(Block wut, GraphicsEngine ge, int x, int y)
	{
		// TODO real render player function rather than by hardcoded View
		simpleFill(ge, Color.white, x, y);
	}
	
	private static void renderDirt(Block wut, GraphicsEngine ge, int x, int y)
	{
		simpleFill(ge, new Color(255, 128, 20), x, y);
	}
	
	private static void renderStone(Block wut, GraphicsEngine ge, int x, int y)
	{
		simpleFill(ge, Color.gray, x, y);
	}
	
	private static void renderAir(Block wut, GraphicsEngine ge, int x, int y)
	{
	}
	
	private static void simpleFill(GraphicsEngine ge, Color cl, int x, int y, int xs, int ys)
	{
		for (int mx=0; mx<xs; mx++)
		{
			for (int my=0; my<ys; my++)
			{
				ge.set(mx+x, my+y, cl);
			}
		}
		
	}
	private static void simpleFill(GraphicsEngine ge, Color cl, int x, int y) { simpleFill(ge, cl, x, y, zoom, zoom); }

}



package view;

import java.awt.Color;

import model.*;

/**The xoff/yoff should always the model.scrollX/Y and it should render fine.
 *  |||Details for the curious:
 * 
 * 
 */

public abstract class RenderEntity {
	private static final int zoom = Model.zoom;
//	private static final int cs   = Chunk.cs;
	private static Model model;
	public static void initModel(Model model) { RenderEntity.model = model; }
	private static double offx() { if (model == null) return 0D; return model.scrollX(); }
	private static double offy() { if (model == null) return 0D; return model.scrollY(); }
	
	public static void render(Entity wut, GraphicsEngine ge, double xoff, double yoff) {
		if (wut instanceof EntityPlayer) renderPlayer(wut, ge,(int)xoff,(int)yoff); else
		if (wut instanceof EntityProjectile) renderProjectile(wut, ge,(int)xoff,(int)yoff);
	}
	
	private static void renderPlayer(Entity wut, GraphicsEngine ge,int x,int y) {
		simpleFill(ge,x,y, Color.white);
	}
	private static void renderProjectile(Entity wut, GraphicsEngine ge,int x,int y) {
		simpleFill(ge,x,y, Color.yellow);
	}
	
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c, int xs, int ys) {
		for (int mx=0; mx<xs; mx++) {
			for (int my=0; my<ys; my++) {
				ge.set(mx+x, my+y, c);
			}
		}
	}
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c) {
		simpleFill(ge, x, y, c, zoom, zoom);
	}
}
















package view;

public class Snippet {
	public int x, y; // start of the snippet
	private Compiz cpz;
	private float[][] map;
	public boolean needremap;
	
	public Snippet(Compiz cpz, float[][] map, int x, int y, Object thisparameterwasaddedtomakeeverysnippetcreationfail) {
		this.cpz = cpz;
		this.map = map;
		this.x = x;
		this.y = y;
	}
	public void destroy() {
		cpz.snippetsRemove(this);
	}
	
	public void move(float relx, float rely) {
		x+=relx;
		y+=rely;
		cpz.needRemap(true);
	}
	public void move(int x, int y) {
		this.x = x;
		this.y = y;
		cpz.needRemap(true);
	}
	
	public float get(int absx, int absy) {
		try {
			return map[absx-x][absy-y];
		} catch (Exception ex) { return 0; }
	}
	public float gethard(int relax, int relay) {
		return map[relax][relay];
	}

	public int getSizeX() { return map.length; }
	public int getSizeY() { return map[0].length; }
	
	public void requestRemap() {
		needremap = true;
		cpz.needRemap(true);
	}
	
}
package view;

import java.awt.Color;

import model.Block;
import model.BlockX;
import model.Chunk;
import model.Inventory;
import model.InventorySlot;
import model.Model;
import model.World;

@SuppressWarnings("serial")
public class View extends GraphicsEngine implements GraphicsEngine.KeyL, GraphicsEngine.MouseL, GraphicsEngine.MouseMotionL {
	
	public View(Model model) {
		super(model);
		this.model = model;
		RenderEntity.initModel(model);
		//addMouseL(this);
		//addMouseMotionL(this);
		//addKeyL(this);
		
		model.getWM().initGE(this);
	}
	
	@Override
	protected void onRender() {
		/* 110627: switching to scaled big blocks. see below
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				Pixie pix = model.getWorld().get(x, y);
				if (pix == null) { continue; }
				pix.render(this);
			}
		}*/
		
		World tmpworld = model.getWorld();
		
		for (int x=0; x<WIDTH/Model.zoom+1; x++) {
			for (int y=0; y<HEIGHT/Model.zoom+1; y++) {
				//Chunk chk = model.getWorld().getChunkAt((int)(x+model.scrollX()), (int)(y+model.scrollY()));
				RenderBlock.render(tmpworld.get((int)(x+model.scrollX()), (int)(y+model.scrollY())), this, x*Model.zoom, y*Model.zoom);
			}
		}
		
		RenderEntity.render(model.getPlayer(), this, model.scrollX(), model.scrollY());
		model.scrollToCentrify(model.getPlayer().getX(), model.getPlayer().getY());
		
		// TODO add entity interation
		// int iteratorhandle = world.enterate();
		// Entity e = world.enterateNext();
		// if (e != null) { do something } else { world.deterate(iteratorhandle); break; }
		// no wait, thats not good. must do it chunk oriented: List<Entity> entities = currentchunk.getEntities();
		
		/*
		for (int x=0; x<WIDTH/Model.zoom+1; x++) {
			for (int y=0; y<HEIGHT/Model.zoom+1; y++) {
				Block block = model.getWorld().get((int)(x+model.scrollX()), (int)(y+model.scrollY()));
				//Pixie p = model.get(x+(int)(Math.floor(model.scrollX()/Model.zoom)),y+(int)(Math.floor(model.scrollY()/Model.zoom)));
				System.out.printf("%f ... %f\n", x+(Math.floor(model.scrollX())), y+(Math.floor(model.scrollY())));
				if (block == null) continue;
				
				for (int cx=0; cx<Model.zoom; cx++) {
					for (int cy=0; cy<Model.zoom; cy++) {
						set((int)(x*Model.zoom +cx), (int)(y*Model.zoom+cy-(model.scrollY()%Model.zoom)), block.getColor());
					}
				}
				
			}
		} */
		
		//console TEXT
		int offs = 1;
		if (!model.termExtend()) {
			for (int i=4; i>=0; i--) { // 3 entries (4-1)
				String str = model.termLast(i); if (str == null) continue;
				text(10, offs+2, str, Color.yellow, 1);
				offs+=7+2;
			}
		} else {
			for (int i=20; i>=0; i--) {
				String str = model.termLast(i); if (str == null) continue;
				text(10, offs+2, str, Color.yellow, 1);
				offs+=7+2;
			}
			
		}
		
	
		// default UI (palette of player)
		Inventory palette = model.getPlayer().getPalette();
		if (palette == null) { System.out.println("CORE [view.View onRender() Palette] Palette null!"); }
		// draw background ( horizontal space needed: (24+2)*8 +2 = 210
		for (int x=WIDTH/2-105; x<WIDTH/2+105; x++) {
			for (int y=HEIGHT-27; y<HEIGHT; y++) {
				set(x,y,Color.GRAY.brighter());
			}
		}
		final int shiftstep = 24; // take 2 as space between each element (on x axis)
		int shift = 0;
		for (int i=0; i<8; i++) {
			shift+=2;
			
			InventorySlot slot = palette.get(i);
			
			if (slot == null || slot.isEmpty()) {
				for (int x=0; x<24; x++) {
					for (int y=0; y<24; y++) {
						set(x+shift+(WIDTH/2-105), y+2+(HEIGHT-27), Color.black.brighter());
					}
				}
				shift+=shiftstep;
				continue;
			}
			
			GSnip icon = slot.getIcon();
			if (icon == null) { System.out.printf("CORE[View onRender: playerpalette] slot#%d's icon is null\n", i); continue; }
			icon.render(this, shift+(WIDTH/2-105), 2+HEIGHT-27, 24, 24);
			
			
			String quantity = ""+slot.getQuantity();
			int len = GraphicsEngine.textlen(quantity, 1);
			text(shift+(WIDTH/2-105)+(Math.abs(24-len)), 2+(HEIGHT-27)+(Math.abs(24-8)), quantity, Color.white, 1); // worked on first go. might be buggy
			
			shift += shiftstep;
		}
		
		
		// player.. // moved to above ^^^^^^
		//for (int cx=0; cx<Model.zoom; cx++) {
		//	for (int cy=0; cy<Model.zoom; cy++) {
		//		set(WIDTH/2+cx-(Model.zoom/2), HEIGHT/2+cy-(Model.zoom/2), Color.white);
		//	}
		//}

		
		// COMPIZ
		// if you uncomment the following, you can get ultimate light effects!
		// model.compizGet().remap(); // now it automatically remaps, only if needed
		//model.compizGet().blend();
		
		
		if (model.useForms()) model.getWM().render();
		/*
		// FORMS GUI
		if (!model.useForms()) return;
		Stack<Form> fstack = model.formGetStack();
		
		// darken pre
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				set(x,y, get(x,y).darker().darker());
			}
		}
		
		// in case of empty
		if (fstack.isEmpty()) {
			int notextlen = textLen("No forms to display", 2);
			text(WIDTH/2-(notextlen/2),50,"No forms to display", new Color(64, 60, 60));
			drawChar(WIDTH/4+4, 50+7*4+3, UNHAPPY, new Color(70, 50, 50), 4);
			return; // !
		}
		
		// ((print all but last))
		for (int i=0; i<fstack.size(); i++) {
			GSnip fcanvas = fstack.get(i).render(this); // form's canvas
			if (fcanvas == null) continue;
			
			int posx = fcanvas.xpos();
			int posy = fcanvas.ypos();
			int lenx = fcanvas.xlen();
			int leny = fcanvas.ylen();
			
			// ==== DRAW FRAME ====
			
			// left & right border
			for (int y=posy-Form.frametop; y<posy+leny+Form.frameborders; y++) {
				set(posx-1, y, Color.white);
			}
			for (int y=posy-Form.frametop; y<posy+leny+Form.frameborders; y++) {
				set(posx+lenx, y, Color.white);
			}
			
		}
		*/
		
		/* old code 110616
		// darken finial
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				set(x,y, get(x,y).darker());
			}
		}
		
		// print last
		fstack.get(fstack.size()-1).render(this);
		*/
	}
	
	@Override
	protected void onUpdate() {
		model.setScrolls();
		if (model.pause()) return;
		
		invokeFrameUpdateListeners();
	}

	
	
	public boolean mouseMoved(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseMoved(x, y);
		} else {
			return false; // TODO
		}
	}
	public boolean mouseDragged(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseDragged(x, y);
		} else {
			return false; // TODO FIXME XXX (and all others). "event waterfall". i.e. call next one if this one hasnt consumed it
		}
	}
	public boolean mouseClicked(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseClicked(x, y);
		} else {
			return false; // TODO
		}
	}
	public boolean keyTyped(char letter) {
		if (model.useForms()) {
			return model.getWM().keyTyped(letter);
		} else {
			return false;
		}
	}
	public boolean keyPressed(int code) {
		if (model.useForms()) {
			return model.getWM().keyPressed(code);
		} else {
			return false; // TODO others also want some events
		}
	}

	@Override
	public boolean mouseDown(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseDown(x,y);
		} else {
			return false; // TODO others also want some events
		}
	}

	@Override
	public boolean mouseUp(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseUp(x,y);
		} else {
			return false; // TODO others also want some events
		}
	}

}








