package model;

import java.awt.Color;

public enum Block {
	air,
	stone,
	player,
	dirt,
	torch; // TODO wire up torch
	
	private int data;
	
	Block() {
	}
	
	Block(int data) {
		this.data = data;
	}
	
	public int getData() { return data; }
	public void setData(int data) { this.data = data; }
	
	public String toString() {
		String ret;
		
		switch(this) {
		case air: ret = "air"; break;
		case stone: ret = "stone"; break;
		case player: ret = "player"; break;
		case dirt: ret = "dirt"; break;
		
		default: ret = "air";
		}
		
		if (data == 0) return ret;
		else           return ret+":"+data;
	}
	
	@Deprecated
	public Color getColor() {
		switch(this) {
		case air: return Color.green;
		case stone: return Color.gray;
		case player: return Color.magenta;
		case dirt: return Color.orange;
		
		default: return Color.blue;
		}
	}
}
