package model;

/**A wrapper for a block giving it x/y coords and the Chunk*/
public class BlockX {
	private final Block original;
	
	private Chunk chunk;
	private double x, y;
	
	public BlockX(Block original) {
		this.original = original;
	}
	public BlockX(Block original, double x, double y) {
		this(original);
		this.x = x;
		this.y = y;
	}
	public BlockX(Block original, Chunk chunk) { this(original); this.chunk = chunk; }
	public BlockX(Block original, double x, double y, Chunk chunk) { this(original, x, y); this.chunk = chunk; } 
	
	public void setChunk(Chunk chunk) { this.chunk = chunk; }
	public Chunk getChunk() { return chunk; }
	public void setX(double x) { this.x = x; }
	public void setY(double y) { this.y = y; }
	public double getX() { return x; }
	public double getY() { return y; }
	public void setPos(double x, double y) { this.x = x; this.y = y; }
	public Block getOrig() { return original; }
}
