package model;

public class EntityAnimation extends Entity {
	private double progress;
	
	public EntityAnimation(World in, double x, double y) {
		super(in, x, y);
	}

	public double getDurationSeconds() { return 1d; }
	
	@Override
	public void update(double delta) {
		progress += delta * getDurationSeconds();
		if (progress >= 1d) destroyme();
	}
	
}
