package model.pixies;

public class Actor extends Pixie {
	public enum Type {
		ERROR,
		NULL,
		STD,

		Player, // Player
		Monster, // Monster
		Thing, // Thing -> Bullet; particle (shrown stone, falling minecraft TNT)
	}
	
	public static final String myname = "Actor";
	protected Type type;
	
	protected int level;
	protected float health;
	
	public static String type2str(Type type) {
		switch (type) {
		case NULL: return "NULL";
		case STD: return "STD";
		case Player: return "Player";
		case Monster: return "Monster";
		case Thing: return "Thing";
		}
		
		return "ERROR";
	}
	
	/**this Actor attacks wut. Only tries to hit */
	public float attack(Pixie wut) {
		return 0f;
	}
	
	
	// super
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return type2str(type); }
	public String getLongType() { return super.getLongType() + "." + type2str(type); }
	
	public Actor(Type type) {
		super(Pixie.Type.Actor);
		this.type = type;
	}
	
}
