package model.pixies;

import java.awt.Color;

import view.GraphicsEngine;

public class Dirt extends Material {
	public static final String myname = "Dirt";
	protected final Color color = new Color(120, 90, 50);
	
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return "("+type2str(type)+")"; }
	public String getLongType() { return super.getLongType() + ".(" + type2str(type) + ")"; }
	
	public String toString() {
		String ret = "d";
		
		return ret;
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), color);
	}
	
	public Dirt() {
		super(Material.Type.Dirt);
	}
	
}
