package model.pixies;

public class Material extends Pixie {
	public enum Type {
		ERROR,
		STD, // should not be used // will render the superclass's engine. (Pixie: Gray)
		AIR, // ugh, prefer Pixie.type to be NULL or the entire object NULL. but hey, for map editors.
		Stone,
		Dirt,
		Water,
		Acid,
		MatrixWall,
	}
	public static String type2str(Type type) {
		switch (type) {
		case STD: return "STD";
		case AIR: return "AIR";
		case Stone: return "Stone";
		case Dirt: return "Dirt";
		case Water: return "Water";
		case Acid: return "Acid";
		case MatrixWall: return "MatrixWall";
		}
		
		return "ERROR";
	}
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return type2str(type); }
	public String getLongType() { return super.getLongType() + "." + type2str(type); }
	public String getShortIdentifier() { return "M"; }
	
	protected Type type;
	
	public Material(Type type) {
		super(Pixie.Type.Material);
		this.type = type;
	}
}
