package model.pixies;

import java.awt.Color;

import view.GraphicsEngine;

public class Stone extends Material {
	public static final String myname = "Stone";
	protected final Color color = new Color(200, 200, 220);
	
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return "("+type2str(type)+")"; }
	public String getLongType() { return super.getLongType() + ".(" + type2str(type) + ")"; }
	
	public String toString() {
		String ret = "s";
		
		return ret;
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), color);
	}
	
	public Stone() {
		super(Material.Type.Stone);
	}
	
}
