package model.pixies;

import java.awt.Color;

import model.Model;

import view.GraphicsEngine;

public class Water extends Material {
	public static final String myname = "Water";
	float x, y, dir, speed;
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return "("+type2str(type)+")"; }
	public String getLongType() { return super.getLongType() + ".(" + type2str(type) + ")"; }
	
	public String toString() { // TODO
		String ret = "w";
		
		return ret;
	}
	
	public Water() {
		super(Material.Type.Water);
	}
	
	@Override
	public void update(Model m, float delta) {
		
		if (m.get((int)x-1, (int)y-1) == null) {
			m.set(x,y, new Water());
		}
		
		
		/*
		final float fall = 1;

		m.set(getX(), getY(), null);
		float px=x, py=y;
		
		Point[] ps = m.raytracePoints(x, y, x, y+fall);
		if (ps == null) {
			y+=fall;
		} else {
			Point[] psl, psr;
			psr = m.raytracePoints(x, y, x+1, y); // right
			psl = m.raytracePoints(x, y, x-1, y); // left
			
			if (psl == null) {
				x+=1;
			} else
			if (psr == null) {
				x-=1;
			} else {
				x=px;
				y=py;
				
				/*
				if (psr[0] != null) {
					
				} else
				if (psl[0] != null) {
					
				} else {
					// give up
					x=px;
				}
				
				* /
			}
			
		}
		*/
		
		/*
		if (m.get( (int)x, (int)y+1 ) == null) {
			y+=fall;
		} else {
			if (m.get( (int)x+1, (int)y )==null) x+=1.37f;
			else if (m.get( (int)x-1, (int)y )==null) x-=1.37f;
		}
		*/
		
		m.set(getX(), getY(), this);
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), new Color(160, 170, 230));
	}
	
	
	
}
