package view;

import java.awt.Color;
import java.util.*;

public class Compiz {
	private float[][] mymap;
	private GraphicsEngine ge;
	private boolean needremap = false;

	public Compiz(GraphicsEngine ge) {
		this.ge = ge;
		// mymap = new float[GraphicsEngine.WIDTH][GraphicsEngine.HEIGHT];
		// remap();
	}

	public GraphicsEngine getGE() {
		return ge;
	}

	/**
	 * So that Pixies can access the add method easier. Don't forget to call
	 * remap() later !
	 * 
	 * @param snip
	 *            Snippet to be added to the list.
	 */
	public void snippetsAdd(Snippet snip) {
		ge.getModel().compizSnippetsAdd(snip);
		needremap = true;
	}

	/**
	 * 
	 * @param snippet
	 */
	public void snippetsRemove(Snippet snip) {
		ge.getModel().compizSnippetsRemove(snip);
		needremap = true;
	}

	public boolean needRemap() {
		return needremap;
	}

	public void needRemap(boolean needremap) {
		this.needremap = needremap;
	}

	public void remap() {/*
						 * System.out.print(
						 * "[view.Compiz.remap()] Remapping alpha values..");
						 * long prevtime = System.currentTimeMillis();
						 * List<Snippet> snippets =
						 * ge.getModel().compizSnippetsGet();
						 * 
						 * 
						 * // clear values for (int x=0; x<ge.WIDTH; x++) { for
						 * (int y=0; y<ge.HEIGHT; y++) { mymap[x][y] = 0; } }
						 * 
						 * // recalculate try { for (int i=0; i<snippets.size();
						 * i++) { Snippet that = snippets.get(i); for (int x=0;
						 * x<that.getSizeX(); x++) { for (int y=0;
						 * y<that.getSizeY(); y++) { mymap[x+that.x][y+that.y]
						 * += that.gethard(x, y); } } } } catch (Exception ex) {
						 * System.out.println("BLAH"); }
						 * 
						 * needremap = false;
						 * System.out.println(" "+(System.currentTimeMillis
						 * ()-prevtime)+"ms");
						 */
	}

	public void blend() {/*
						 * if (needremap) remap();
						 * 
						 * for (int x=0; x<ge.WIDTH; x++) { for (int y=0;
						 * y<ge.HEIGHT; y++) { //if (mymap[x][y] == 0) continue;
						 * 
						 * Color c = ge.get(x, y); float
						 * r=c.getRed()/255.0f,g=c.
						 * getGreen()/255.0f,b=c.getBlue()/255.0f;
						 * 
						 * r += mymap[x][y]; g += mymap[x][y]; b += mymap[x][y];
						 * 
						 * if (r<0)r=0; if (r>1)r=1; if (g<0)g=0; if (g>1)g=1;
						 * if (b<0)b=0; if (b>1)b=1;
						 * 
						 * ge.set(x, y, new Color(r,g,b)); } }
						 */
	}
}
