package view.gui;

import java.awt.Color;

import view.GSnip;

public class HealthBar extends Component {
	float howmuch; // 0f-1f
	int step; // 0-4

	public HealthBar() {
		super();
		step = 0;
		howmuch = 1f;

		ys = 8;
		xs = 150;
	}

	public void setProgress(float howmuch) {
		if (howmuch < 0f || howmuch > 1f) {
			return;
		}
		this.howmuch = howmuch;
	}

	// horizontal always
	public GSnip redraw() {
		GSnip gs = new GSnip(xs, ys);

		step++;
		// if (step>5) step=0;

		for (int x = 0; x < xs; x++) {
			for (int y = 0; y < ys; y++) {
				gs.set(x, y, new Color(90, 90, 15,
						(int) (Math.random() * 80 + 150)));
			}
		}

		Color cempty = new Color(70, 35, 70, 80);
		Color c0 = new Color(250, 100, 50, 255); // false
		Color c1 = new Color(200, 70, 100, 250); // true

		Color use;
		boolean c = false;

		for (int x = 1; x < xs - 1; x++) {
			use = cempty;
			c = false;
			for (int y = 1; y < ys - 1; y++) {
				use = c1;
				if ((x + step + y) % 100 == 0) {
					use = c0;
				}

				if ((float) x / (float) xs > howmuch) {
					use = cempty;
				}
				gs.setraw(x, y, use);
			}
		}

		return gs;
	}
}
