package model;

import mutil.MUtil;
import mutil.Vector2;

public class EntitySprite extends Entity {

	double dir, speed;
	
	public EntitySprite(World in, double x, double y) {
		super(in, x, y);
		dir = 0;
		speed = 0;
	}
	
	public void push(double dir, double speed) {
		Vector2 v = MUtil.combineSpeeds(dir, speed, this.dir, this.speed);
		if (v==null) return;
		
		this.dir = v.dir;
		this.speed = v.speed;
	}

	
	@Override
	public void update(double delta) {
		move(Math.cos(dir)*speed*delta, Math.sin(dir)*speed*delta);
	}
}













