package model;

import java.util.List;

public class EntityMonster extends Entity {
	int hp, maxhp;

	EntityPlayer facetoface;

	public EntityMonster(World in, double x, double y) {
		super(in, x, y);
		maxhp = 20;
		hp = maxhp;
	}

	@Override
	public boolean isOpaque() { return true; }
	public double insL() { return 0; }
	public double insR() { return 0; }
	public double insT() { return 0; }
	public double insB() { return 0; }

	@Override
	public void update(double delta) {// if (true) return;

		List<Entity> es = world.getEntities();

		double speed = 4 * delta;

		for (Entity e : es) {
			if (e instanceof EntityPlayer) {
				if (e.getX() < x) {
					this.x -= speed;
				} else {
					this.x += speed;
				}
				if (e.getY() < y) {
					this.y -= speed;
				} else {
					this.y += speed;
				}
				break;
			}
		}
	}

}
