package model.pixies;

import  java.awt.Color;

import model.Model;

import view.GraphicsEngine;

public class Spawner extends Thing {
	public static final String myname = "Spawner";
	private Pixie wut;
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return "("+type2str(type)+")"; }
	public String getLongType() { return super.getLongType() + ".(" + type2str(type) + ")"; }
	
	public String toString() {
		String ret = "![2s]"; // set2's "s" 
		
		return ret;
	}
	
	@Override
	public void update(Model m, float delta) {
		if (wut == null) return;
		
		if (true) { // % chance Math.random() < 0.59
			for (int i=0; i<3; i++) {
				Bullet b = new Bullet(Bullet.Type.STD, (float)(Math.random())*6f, 2);
				b.x = x+(int)(50-Math.random()*100); 
				b.y = y+(int)(50-Math.random()*100);
				m.entenAdd(b);
			}
			/*
			Pixie thing;
			if (Math.random() < 0.1) {
				thing = new Water();
			} else thing = new Acid();
			thing.x = x; thing.y = y;
			//m.entenAdd(w); // TODO
			m.set(x, y, thing);
			*/
		}
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), Color.magenta);
	}
	
	public Spawner(Pixie wut) {
		super(Thing.Type.Spawner);
		this.wut = wut;
	}

}
