package view;

import java.awt.Color;

import model.*;

/**The xoff/yoff should always the model.scrollX/Y and it should render fine.
 *  |||Details for the curious:
 * 
 * 
 */

public abstract class RenderEntity {
	private static final int zoom = Model.zoom;
//	private static final int cs   = Chunk.cs;
	private static Model model;
	public static void initModel(Model model) { RenderEntity.model = model; }
	private static int offx() { if (model == null) return 0; return model.scrollX(); }
	private static int offy() { if (model == null) return 0; return model.scrollY(); }
	
	public static void render(Entity wut, GraphicsEngine ge, int xoff, int yoff) {
		if (wut instanceof EntityPlayer)				renderPlayer				(wut, ge); else
		if (wut instanceof EntityProjectile)			renderProjectile			(wut, ge); else
		if (wut instanceof EntityMonster)				renderMonster				(wut, ge);
	}
	
	private static void renderMonster(Entity wut, GraphicsEngine ge) { simpleRender(wut, ge, Color.red); }
	private static void renderPlayer(Entity wut, GraphicsEngine ge) { simpleRender(wut, ge, Color.white); }
	private static void renderProjectile(Entity wut, GraphicsEngine ge) { simpleRender(wut, ge, Color.yellow); }
	
	private static void simpleRender(Entity wut, GraphicsEngine ge, Color c) { simpleFill(ge,(int)((wut.getX()-offx())*zoom),(int)((wut.getY()-offy())*zoom), c); }
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c) { simpleFill(ge, x, y, c, zoom, zoom); }
	
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c, int xs, int ys) {
		for (int mx=0; mx<xs; mx++) {
			for (int my=0; my<ys; my++) {
				ge.set(mx+x, my+y, c);
			}
		}
	}
}


/* 110703: before coord fix.
package view;

import java.awt.Color;

import model.*;

/**The xoff/yoff should always the model.scrollX/Y and it should render fine.
 *  |||Details for the curious:
 * 
 * 
 * /

public abstract class RenderEntity {
	private static final int zoom = Model.zoom;
//	private static final int cs   = Chunk.cs;
	private static Model model;
	public static void initModel(Model model) { RenderEntity.model = model; }
	private static int offx() { if (model == null) return 0; return model.scrollX(); }
	private static int offy() { if (model == null) return 0; return model.scrollY(); }
	
	public static void render(Entity wut, GraphicsEngine ge, int xoff, int yoff) {
		if (wut instanceof EntityPlayer)				renderPlayer				(wut, ge,xoff,yoff); else
		if (wut instanceof EntityProjectile)			renderProjectile			(wut, ge,xoff,yoff);
	}
	
	private static void renderMonster(Entity wut, GraphicsEngine ge) {
		
	}
	private static void renderPlayer(Entity wut, GraphicsEngine ge,int x,int y) {
		simpleFill(ge,x,y, Color.white);
	}
	private static void renderProjectile(Entity wut, GraphicsEngine ge,int x,int y) {
		simpleFill(ge,x,y, Color.yellow);
	}
	
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c, int xs, int ys) {
		for (int mx=0; mx<xs; mx++) {
			for (int my=0; my<ys; my++) {
				ge.set(mx+x, my+y, c);
			}
		}
	}
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c) { simpleFill(ge, x, y, c, zoom, zoom); }
}

















 */











