package view;

public class Snippet {
	public int x, y; // start of the snippet
	private Compiz cpz;
	private float[][] map;
	public boolean needremap;
	
	public Snippet(Compiz cpz, float[][] map, int x, int y, Object thisparameterwasaddedtomakeeverysnippetcreationfail) {
		this.cpz = cpz;
		this.map = map;
		this.x = x;
		this.y = y;
	}
	public void destroy() {
		cpz.snippetsRemove(this);
	}
	
	public void move(float relx, float rely) {
		x+=relx;
		y+=rely;
		cpz.needRemap(true);
	}
	public void move(int x, int y) {
		this.x = x;
		this.y = y;
		cpz.needRemap(true);
	}
	
	public float get(int absx, int absy) {
		try {
			return map[absx-x][absy-y];
		} catch (Exception ex) { return 0; }
	}
	public float gethard(int relax, int relay) {
		return map[relax][relay];
	}

	public int getSizeX() { return map.length; }
	public int getSizeY() { return map[0].length; }
	
	public void requestRemap() {
		needremap = true;
		cpz.needRemap(true);
	}
	
}
