package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class Button extends Component {
	
	protected String text;
	
	public Button() {
		super();
		text = "Button";
		initSize(80, 15);
		initPosition(0,0);
	}
	
	@Override
	public GSnip redraw() {
		GSnip gs = new GSnip(xs,ys);
		
		for (int x=0; x<xs; x++) {
			for (int y=0; y<ys; y++) {
				gs.setraw(x, y, new Color(100, 200, 100, 200));
			}
		}
		
		GraphicsEngine.gstext(4, 4, text, Color.GREEN, 1, gs);
		
		return gs;
	}
	
	protected void oClick() {
		text = "ouch!";
	}
	
	public boolean eventMouseClick(int x, int y) {
		oClick();
		return true;
	}

	public void setText(String text) {
		this.text = text;
	}
}
