package model;

public class EntitySpawner extends Entity {

	Class type;
	
	double hold;
	
	public EntitySpawner(World in, double x, double y, Class type) { super(in, x, y); this.type = type; }
	public EntitySpawner(World in, double x, double y, Entity typesample) { this(in,x,y, typesample.getClass()); }
	
	@Override
	public void update(double delta) {
		hold+=delta;
		if (hold>=10) {
			try {
				type.getConstructor(World.class, double.class, double.class).newInstance(world, this.x, this.y );
				hold = 0;
			} catch (Exception e) { System.out.printf("WORLD LOGIC [Entity %d (Spawner)] Could not spawn instance\n", eid); }
		}
	}

}
