package view.gui;

import view.GSnip;

/** init* resize move redraw */
public class Component implements WindowManager.KeyL, WindowManager.MouseL,
		WindowManager.MouseMotionL {
	int x, y, xs, ys; // coords and size (on the parent container)
	Container myparent; // direct parent (the container) (if null: this is
						// mywindow's 'the')
	Window mywindow; // the window we are inside.

	public void initW(Window window) {
		this.mywindow = window;
	}

	public void initParent(Container myparent) {
		this.myparent = myparent;
	}

	public void initSize(int xs, int ys) {
		this.xs = xs;
		this.ys = ys;
	}

	public void initPosition(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public Component() {
		x = 0;
		y = 0;
		xs = 1;
		ys = 1;
	}

	/** Do not use yet */
	public void poke() {
	} // request for redraw. (useful for containers only)

	public void resize(int xs, int ys) {
		this.xs = xs;
		this.ys = ys;
	}

	public void move(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public GSnip redraw() {
		return null;
	}

	public boolean eventMouseClick(int x, int y) {
		return false;
	}

	public boolean eventMouseMove(int x, int y) {
		return false;
	}

	public boolean eventMouseDrag(int x, int y) {
		return false;
	}

	public boolean eventKeyCode(int code) {
		return false;
	}

	public boolean eventKeyChar(char chr) {
		return false;
	}
}
